CREATE OR REPLACE PACKAGE BODY gassignment_pkg AS
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/                        _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/  ASSIGNMENT PROCEDURES  /_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_                       _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--------------------------------------------------------------------
--##################################################################
-- assignmentManipulationPage
--##################################################################
PROCEDURE assignmentManipulationPage(	unum IN vARCHAR2,
					crsTitle IN VARCHAR2,url_left IN VARCHAR2,url_right IN VARCHAR2)
IS
BEGIN 
	htp.bp('
<html>
<title>'||crsTitle||' Assignments </title>
<frameset cols="200,*" border=0>
<frame src="'||gsystem_pkg.cgi||'gassignment_pkg.listAssignments?unum='||unum||'&'||'crsTitle='||crsTitle||'" name=menu scrolling=yes frameborder=0 marginwidth=2 marginheight=2>
<frame src="'||gsystem_pkg.cgi||'gassignment_pkg.assignment?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode=&'||'assID=&'||'script=" name=info scrolling=yes frameborder=0>
</frameset>
<noframe>
<body bgcolor=white>
<h2>Error: You need frames for this!</h2></body></noframe>
<font size=-1><i>NPAC</i></font>
</body></html>
 ');
END assignmentManipulationPage;
--------------------------------------------------------------------
--##################################################################
-- listAssignment
--##################################################################
PROCEDURE listAssignments(unum IN VARCHAR2,crsTitle IN VARCHAR2)
IS
	assign_cur 	GenericCurType;
	ass		XXassignmentsXX%ROWTYPE;
	courseURL	varchar2(200);
BEGIN
	SELECT url INTO courseURL FROM XXcoursesXX WHERE courseTitle=crsTitle;
	htp.p('
<html><body bgcolor=white>
<base target=info>');
	gsystem_pkg.backGuaranteed;
	htp.bp('
<table>
<tr><td>');
	IF courseURL IS NULL THEN
		htp.bp('
<img src='||gsystem_pkg.images||'homeempty.jpg border=0 align=center> </td>	
		');
	ELSE
		htp.bp('<a href='||courseURL||'>');
		htp.bp('<img src='||gsystem_pkg.images||'homefull.jpg border=0></a></td>');
	END IF;
	htp.p('</td>
<td><b>'||crsTitle||'</b></td></tr>
<td colspan=2><hr></td></tr>
	');
	IF NOT assign_cur%ISOPEN THEN      -- open the cursor if
	            gsystem_pkg.open_cv (assign_cur,'XXassignmentsXX',crsTitle);    -- not open yet
        END IF;
 	-- Fetch rows into PL/SQL table
	LOOP
		FETCH assign_cur INTO ass;
                EXIT WHEN assign_cur%NOTFOUND;
			
		IF ass.url IS NULL THEN
			htp.bp('
<tr><td>
<img src='||gsystem_pkg.images||'homeempty.jpg border=0 align=center> 
</td>	
			');
		ELSE
			htp.bp('
<tr><td>
<a href='||ass.url||'>
<img src='||gsystem_pkg.images||'homefull.jpg border=0 align=center></a> 
</td>
			');
		END IF;
		htp.bp('
<td><a 
href="'||gsystem_pkg.cgi||'gassignment_pkg.assignment?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode=show&'||'assID='||ass.assID||'&'||'script=" 
><b>'||ass.Typ||' '||ass.assID||'</a>
			');
		IF NOT ass.commentURL IS NULL THEN
			htp.p('<a href='||ass.commentURL||' >*</a>');
		END IF;
		htp.bp('<a target=menu  href="'||gsystem_pkg.cgi||'gassignment_pkg.publishAssignment?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'VassID='||ass.assID||'&'||'pub=');
		IF ass.publish='YES' THEN
			htp.p('NO"><img src="'||gsystem_pkg.images||'green_light.gif" height=30 width=31  border=0></a>');
		ELSE
			htp.p('YES"><img src="'||gsystem_pkg.images||'red_light.gif" height=32 width=31 border=0></a>');
		END IF;
		htp.p('</b></td></tr>');
         END LOOP;
        CLOSE assign_cur;
	htp.bp('
<td colspan=2><hr></td></tr>
</table></body></html><font size=-1><i>NPAC</i></font>');
	gsystem_pkg.backGuaranteed;
	htp.p(' </body></html>
	');
END listAssignments;
--------------------------------------------------------------------
--##################################################################
-- publishAssignment
--##################################################################

PROCEDURE publishAssignment(		unum IN VARCHAR2,		--*- no security -*--
						crsTitle IN VARCHAR2,
						VassID IN VARCHAR2,
						pub IN VARCHAR2
						)
IS
	assign_cur 	GenericCurType;
	ass		XXassignmentsXX%ROWTYPE;
	courseURL	varchar2(200);
BEGIN
	UPDATE XXassignmentsXX a
	SET  	
		a.publish=pub
	WHERE a.course=crsTitle AND a.assID=VassID;
	COMMIT;
	listAssignments(unum,crsTitle );
END  publishAssignment;
--------------------------------------------------------------------
--##################################################################
-- selectAssignment(crsTitle,assID,ass);	
--##################################################################
PROCEDURE selectAssignment(VcrsTitle IN VARCHAR2,VassID IN NUMBER,ass OUT XXASSIGNMENTSXX%ROWTYPE)
IS
BEGIN
	SELECT * INTO ass FROM XXassignmentsXX a WHERE a.course=VcrsTitle AND a.assID=VassID;
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		ass.assID:=VassID;
END ;
--------------------------------------------------------------------
--##################################################################
-- getHTMLformatShow(crsTitle,assID);
--##################################################################
PROCEDURE getHTMLformatShow(crsTitle IN VARCHAR2,assID IN NUMBER,hidden_str OUT VARCHAR2)
IS
	ass	XXassignmentsXX%ROWTYPE;
BEGIN
	selectAssignment(crsTitle,assID,ass);	
	htp.bp('
<table bgcolor=green ><th>
<table bgcolor=yellow cellpadding=6 border=5 >
<tr><td width=200><b>Assignment #</b></td><td>'||ass.assID||'</td></tr>
<tr><td width=200><b>Assignment Type</b></td><td>'||ass.Typ||'</td></tr>
<tr><td><b>Grading Base </b></td><td>'||ass.gBase||' <b> Partials </b> '||ass.partials||' </td></tr>
<tr><td><b>Weight</b></td><td>'||ass.weight||'%</td></tr>
<tr><td><b>Grades Published </b></td><td>'||ass.publish||'</td></tr>
<tr><td><b>Assignment URL </b></td><td>'||ass.url||'<br></td></tr>
<tr><td><b>Comment URL </b></td><td>');htp.bp(ass.commentURL);htp.bp('</td></tr>
<tr><td><b>Notes</b></td><td>');	htp.bp(ass.Notes);	htp.bp('<br></td></tr>
</table>
</th>
</table>
		');
	hidden_str:='	<input type=hidden name=assID value="'||TO_CHAR(ass.assID)||'">
			<input type=hidden name=T value="">
			<input type=hidden name=gBase value="">
			<input type=hidden name=weight value="">
			<input type=hidden name=publish	value="">
			<input type=hidden name=url value="">
			<input type=hidden name=commURL value="">
			<input type=hidden name=notes value="">
			<input type=hidden name=partials value="">
		';
END getHTMLformatShow;
--------------------------------------------------------------------
--##################################################################
-- getHTMLformatEdit(crsTitle,assID);
--##################################################################
PROCEDURE getHTMLformatEdit(crsTitle IN VARCHAR2,assID IN NUMBER) 
IS
	ass		XXassignmentsXX%ROWTYPE;
	grade_cur 	GenericCurType;
	agrade		XXgrade_customizeXX%ROWTYPE;
	grades		VARCHAR2(10000);
	gradeType 	VARCHAR2(100);
	atype		VARCHAR(300);
BEGIN
	selectAssignment(crsTitle,assID,ass);	
	SELECT	assType INTO gradeType FROM XXcoursesXX c WHERE c.courseTitle=crsTitle;
	IF gradeType='customized' THEN
		IF NOT grade_cur%ISOPEN THEN      -- open the cursor if
	            	gsystem_pkg.open_cv (grade_cur,'XXgrade_customizeXX',crsTitle);    -- not open yet
	        END IF;
	 	-- Fetch rows into PL/SQL table
		LOOP
			FETCH grade_cur INTO agrade;
      		        EXIT WHEN grade_cur%NOTFOUND;
			grades:=grades||'<option value='||agrade.grade||'>'||agrade.grade||chr(10);
	        END LOOP;
        	CLOSE grade_cur;
        END IF;
	IF ass.Typ='Project' then 
		atype:='<select name=T><option value="A" >Assignment<option value="Extra">Extra<option value="Project" selected >Project<option value="zAverage" >Average</select>';
	elsif ass.Typ='Extra'then 
		atype:='<select name=T><option value="A" >Assignment<option value="Extra" selected >Extra<option value="Project">Project<option value="zAverage" >Average</select>';
	elsif ass.Typ='zAverage' then 
		atype:='<select name=T><option value="A">Assignment<option value="Extra">Extra<option value="Project">Project<option value="zAverage" selected >Average</select>';
	else
 		atype:='<select name=T><option value="A" selected>Assignment<option value="Extra">Extra<option value="Project">Project<option value="zAverage" selected >Average</select>';
	end IF;
	--
	htp.bp('
<table bgcolor=green><th>
<table bgcolor=yellow cellpadding=6>
<tr><td width=200><b>Assignment #</b></td><td>
<input name=assID size=3 value="'||ass.assID||'"><b> Type '|| atype ||'</td></tr>');
	IF gradeType='customized' THEN
		grades :='<select name=gBase><option value='||ass.gBase||'>'||ass.gBase||grades||'</select>';
		htp.bp('<tr><td><b>Grading Base</b></td><td>'||grades||' <b>Partials</b><input name=partials size=5 value="'||ass.partials||'"></td></tr>');
	ELSE
		htp.bp('
<tr><td><b>Grading Base</b><br><font color=red size=-1>Numeric option selected</font></td><td><input name=gBase size=5 value="'||ass.gBase||'"> <b>Partials</b><input name=partials size=5 value="'||ass.partials||'"> </td></tr>
		');
	END IF;
	htp.bp('
<tr><td><b>Weight </b></td><td><input name=weight size=3 value="'||ass.weight||'">%<br></td></tr>
<tr><td><b>Grade Published </b></td><td><select  name=publish>');
	IF ass.publish='YES' THEN
		htp.p('<option selected>YES<option>NO');
	ELSE 	htp.p('<option>YES<option selected>NO');
	END IF;
	htp.bp('</select><br></td></tr>
<tr><td><b>Assignment URL </b></td><td><input name=url size=30 value="'||ass.url||'"><br></td></tr>
<tr><td><b>Comment URL </b></td><td><input name=commURL size=30 value="'); htp.bp(ass.commentURL);htp.bp('"><br></td></tr>
<tr><td><b>Notes</b></td><td><textarea  name=notes rows=5 cols=30>'); 	htp.bp(ass.Notes); htp.bp('</textarea><br></td></tr>
</table>
</th>
</table>
	');
END getHTMLformatEdit;
--------------------------------------------------------------------
--##################################################################
-- assignment(assID IN NUMBER);
--##################################################################
PROCEDURE assignment(unum IN VARCHAR2,crsTitle IN VARCHAR2,commMode IN VARCHAR2, assID IN  NUMBER,script IN VARCHAR2)
IS
	hidden_str	VARCHAR2(2010);
BEGIN
	hidden_str:='	<input type=hidden name=assID value=""><input type=hidden name=T value="">
			<input type=hidden name=gBase value=""><input type=hidden name=weight value="">
			<input type=hidden name=publish value="">
			<input type=hidden name=url value="">
			<input type=hidden name=commURL value="">
			<input type=hidden name=notes value="">
			<input type=hidden name=partials value="">
		    ';
	htp.bp('
<html>'||script||'<body bgcolor=white>
<b>
<form action='||gsystem_pkg.cgi||'gassignment_pkg.commandServer
method="GET">
<input type=hidden name=unum  value="'||unum||'"> 
<input type=hidden name=crsTitle  value="'||crsTitle||'">
	');
	IF assID IS NULL THEN
		htp.bp('<font color=black size=+1 FACE="Arial,Helvetica" ><b>
			<input type=submit name=request value="NEW"></b></font>');
		htp.bp(hidden_str||'<br><h2>Please click on the name of the assignment which you want to manipulate!</h2>');
	ELSIF commMode='add' THEN   --  new assignment
		htp.p('<b><font color=red size=+1 FACE="Arial,Helvetica" >
			<input type=submit name=request value="ADD" >');
		htp.p('<font color=black>
			<input type=reset name=request value="UNDO" > </font>');
		htp.p('<font color=black>
			<input type=submit name=request value="SKIP" ></font></font></b>');
	ELSIF commMode='edit' THEN 
		htp.p('<b><font color=red size=+1 FACE="Arial,Helvetica" >
			<input type=submit name=request value="UPDATE" >');
		htp.p('<font color=black>
			<input type=reset name=request value="UNDO" >');
		htp.p('
			<input type=submit name=request value="SKIP" >');
		htp.p('
			<input type=submit name=request value="CANCEL" ></font></font></b>');
	ELSE    
		htp.p('<b><font color=black size=+1 FACE="Arial,Helvetica" >
			<input type=submit name=request value="NEW" >');
		htp.p('<font color=red >
			<input type=submit name=request value="DELETE" ></font>');
		htp.p('
			<input type=submit name=request value="EDIT" >');
		htp.p('
			<input type=submit name=request value="SKIP" ></font></b>');
	END IF;
--      * ********************
	IF commMode='show' THEN
		getHTMLformatShow(crsTitle,assID,hidden_str);
		htp.bp(hidden_str);
	ELSIF  commMode='add' OR commMode='edit'  THEN
		getHTMLformatEdit(crsTitle,assID);
	END IF;
	htp.bp('</form><hr><font size=-1><i>NPAC</i></font> </body></html>');
END assignment;
--------------------------------------------------------------------
--##################################################################
-- addAssignment(crsTitle,assID,gBase,url,commUrl,notes);
--##################################################################
PROCEDURE addAssignment(VcrsTitle IN VARCHAR2,VassID IN NUMBER,Vt IN VARCHAR2,VmaxGrade IN VARCHAR2,Vweight IN NUMBER,Vurl IN VARCHAR2,VcommUrl IN VARCHAR2,Vnotes IN VARCHAR2,Vpartials IN VARCHAR2,Vpublish IN VARCHAR2)
IS
BEGIN
	INSERT INTO XXassignmentsXX
	VALUES(VcrsTitle,VassID,Vt,VmaxGrade,Vweight,Vurl,VcommUrl,Vnotes,Vpartials,Vpublish);
	IF SQL%NOTFOUND THEN
		gsystem_pkg.printErrorPage('System failed to add!');	
	END IF;
	COMMIT;
	EXCEPTION
		WHEN DUP_VAL_ON_INDEX THEN
			gsystem_pkg.printErrorPage('This assignment number,'||VassID||' already exists! You may update it, but duplication is not allowed!');
END addAssignment;
--------------------------------------------------------------------
--##################################################################
-- updateAssignment(crsTitle,assID,maxGrade,commentUrl,notes);
--##################################################################
PROCEDURE updateAssignment(VcrsTitle IN VARCHAR2,VassID IN NUMBER,Vt IN VARCHAR2,VmaxGrade IN VARCHAR2,Vweight IN NUMBER,Vurl IN VARCHAR2,VcommUrl IN VARCHAR2,Vnotes IN VARCHAR2,Vpartials IN VARCHAR2,Vpublish IN VARCHAR2 )
IS
BEGIN
	UPDATE XXassignmentsXX a
	SET  	a.course=VcrsTitle,
		a.assID=VassID,
		a.Typ=Vt,
		a.gBase=VmaxGrade,
		a.weight=Vweight,
		a.url=Vurl,
		a.commentUrl=VcommURL,
		a.notes=Vnotes,
		a.partials=Vpartials,
		a.publish=Vpublish
	WHERE a.course=VcrsTitle AND a.assID=VassID;
	COMMIT;
	IF SQL%NOTFOUND THEN
		--gsystem_pkg.printErrorPage('System failed to update! Trying as a new assignment!');		
		addAssignment(VcrsTitle ,VassID,Vt,VmaxGrade ,Vweight,Vurl,VcommUrl ,Vnotes,Vpartials,Vpublish);
	END IF;
END updateAssignment  ;
--------------------------------------------------------------------
--##################################################################
-- deleteAssignment(crsTitle,assID);
--##################################################################
PROCEDURE deleteAssignment(VcrsTitle IN VARCHAR2,VassID IN VARCHAR2)
IS
BEGIN
	DELETE FROM XXassignmentsXX a
	WHERE a.course=VcrsTitle AND a.assID=VassID;
	COMMIT;
	IF SQL%NOTFOUND THEN
		gsystem_pkg.printErrorPage('System failed to delete!<br> Record may be deleted already!');	
	END IF;
END deleteAssignment;
--------------------------------------------------------------------
--##################################################################
-- commandServer
--##################################################################
PROCEDURE commandServer(unum IN VARCHAR2,crsTitle IN VARCHAR2,request IN VARCHAR2, assID IN NUMBER,T IN VARCHAR2, gBase IN VARCHAR2,weight IN NUMBER,publish IN VARCHAR2, url IN VARCHAR2, commUrl IN VARCHAR2, notes IN VARCHAR2,partials IN VARCHAR2)
IS
	last NUMBER(3) DEFAULT 0;
BEGIN
	IF request='ADD' THEN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'assignment:CS:'||request) THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
		addAssignment(crsTitle,assID,t,gBase,weight,url,commUrl,notes,partials,publish);
		assignment(unum,crsTitle,'show',assID,'<script language=JavaScript> top.menu.document.location.reload();</script>');
	ELSIF request='NEW' THEN
		SELECT MAX(a.assID) INTO last FROM XXassignmentsXX a WHERE crsTitle=a.course ;
		IF last IS NULL THEN last:=0;
		END IF;
		last:=last+1;
		assignment(unum,crsTitle,'add',last,NULL);
	ELSIF request='DELETE' THEN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'assignment:CS:'||request) THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
		deleteAssignment(crsTitle,assID);
		htp.p('<html> <script language=JavaScript> top.document.location.reload();</script></html>');
	ELSIF request='UPDATE' THEN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'assignment:CS:'||request) THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
		updateAssignment(crsTitle,assID,t,gBase,weight,url,commUrl,notes,partials,publish);
		assignment(unum,crsTitle,'show',assID,'<script language=JavaScript> top.menu.document.location.reload();</script>');
		--showAssignment(crsTitle,assID);
	ELSIF request='EDIT' THEN
		assignment(unum,crsTitle,'edit',assID,NULL);
	ELSIF request='CANCEL' THEN
		htp.p('<html> <script language=JavaScript> history.go(-2);</script></html>');
		assignment(unum,crsTitle,NULL,NULL,NULL);
	ELSIF request='SKIP' THEN
		assignment(unum,crsTitle,NULL,NULL,NULL);
	END IF;
END commandServer;
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
END gassignment_pkg;
/
show err














