CREATE OR REPLACE PACKAGE gcourse_pkg AS
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	TYPE GenericCurType is REF CURSOR;
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	PROCEDURE courseManipulationPage(unum IN VARCHAR2);       --*- no security -*--

	PROCEDURE courseManipulation(	unum IN VARCHAR2,
					course IN VARCHAR2,
					term   IN VARCHAR2,
					year 	IN VARCHAR2,
					request IN VARCHAR2);
	PROCEDURE courseUpdate(
				unum    IN VARCHAR2,
				oldtitle IN VARCHAR2,
				cname	IN VARCHAR2,
				Vterm	IN VARCHAR2,
				Vyear	IN VARCHAR2,
				Vinstructor	IN VARCHAR2,
				Vinsurl	IN VARCHAR2,
				Vinsemail	IN VARCHAR2,
				Vta	IN VARCHAR2,
				Vtaurl	IN VARCHAR2,
				Vtaemail	IN VARCHAR2,
				Vteam	IN VARCHAR2,
				Vurl	IN VARCHAR2,
				Vnumberofass	IN VARCHAR2,
				gtype	IN VARCHAR2,
				comments	IN VARCHAR2
				);

	PROCEDURE courseDelete(	unum IN VARCHAR2,crsTitle IN VARCHAR2, choice IN VARCHAR2);

	PROCEDURE gradingCustomizePage(
				unum IN VARCHAR2,
				course IN VARCHAR2);	--*- no security -*--

	PROCEDURE gradingCustomize(
				unum    IN VARCHAR2,
				courseTitle IN VARCHAR2,
				oldGrade IN VARCHAR2, 
				newGrade IN VARCHAR2,
				newNumeric IN NUMBER, 
				request IN VARCHAR2
				);

	PROCEDURE surveyPage(crsTitle IN VARCHAR2);          --*- no security -*--

	PROCEDURE survey(	request IN VARCHAR2,   --*- no security -*--
				surveyname IN VARCHAR2,
				skip	IN VARCHAR2,
				qn IN NUMBER, 
				qst IN VARCHAR2,
				catg IN VARCHAR2,
				crsTitle IN VARCHAR2,
				list IN VARCHAR2);
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
END gcourse_pkg;
/
show err

