CREATE OR REPLACE PACKAGE BODY ggrading_pkg AS
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/                        _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/  GRADING PROCEDURES     /_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_                       _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--------------------------------------------------------------------
--##################################################################
-- gradingMenuPage
--##################################################################
PROCEDURE gradingMenuPage(	unum IN vARCHAR2,
					crsTitle IN VARCHAR2)
IS
BEGIN 
	htp.bp('
	<html> <header><title>Grading Menu</title></header>
	<body bgcolor=white>
	<h1>Grading Choice :</h1>
	<table><tr><td>
	<font color=blue size=-1 FACE="Arial,Helvetica" >
Please select the the type of grading from followings.
	<b><font color=black size=+2 FACE="Arial,Helvetica" >
	<form action='||gsystem_pkg.cgi||'ggrading_pkg.gradingManipulationPage
	method="POST">
	<input type=hidden name=unum  value="'||unum||'"> 
	<input type=hidden name=crsTitle value="'||crsTitle||'">
	<ul><input type=submit name=choice value="  Assignments listed " >
	<ul><input type=submit name=choice value="  Students listed " >
	</td><td bgcolor=blue>|</td><td>
	<b><font color=black size=+2 FACE="Arial,Helvetica" >
	<ul><input type=submit name=choice value="  Statistics     " >
	</td></tr></table>
	<br><br><br><br><p><p>
	<h1>Course survey results : </h1>
	<b><font color=black size=+2 FACE="Arial,Helvetica" >
	<ul><ul><ul><ul><input type=submit name=choice value="  Survey  " >
	</ul></ul></ul></ul>
	</b></font>
	<br><br><br><br><p><p>
	<h1>Grading Options : </h1>
	<b><font color=black size=+2 FACE="Arial,Helvetica" >
	<ul><ul><ul><ul><ul><input type=submit name=choice value="  Set Options  " >
	</form></b></font>
	</form>
	<font color=blue size=-1><i><ul><ul>NPAC</i></font>
	</body></html>
 	');
END gradingMenuPage;
--------------------------------------------------------------------
--##################################################################
-- gradingManipulationPage
--##################################################################
PROCEDURE gradingManipulationPage(	unum IN vARCHAR2,
					crsTitle IN VARCHAR2,choice IN VARCHAR2)
IS
BEGIN 
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'grading:gradingManipulationPage:'||choice) THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF choice like '%Survey%' THEN
		std.commandServer(unum,crsTitle,NULL,'SURVEY STATISTICS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
		RETURN;
	END IF;
	htp.bp('
<html>
<title>'||crsTitle||' Gradings </title>
<frameset cols="200,*" border=0>
	');
	IF choice like '%Assignments%' THEN
		htp.bp('
<frame src="'||gsystem_pkg.cgi||'ggrading_pkg.listAssignments?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode=GRADE" name=menu scrolling=yes frameborder=0 marginwidth=2 marginheight=2>
<frame src="'||gsystem_pkg.cgi||'ggrading_pkg.Assignment?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode=GRADE&'||'VassID=" name=info scrolling=yes frameborder=0>
		');
	ELSIF choice like '%Students%' THEN
		htp.bp('
<frame src="'||gsystem_pkg.cgi||'ggrading_pkg.listStudents?unum='||unum||'&'||'crsTitle='||crsTitle||'" name=menu scrolling=yes frameborder=0 marginwidth=2 marginheight=2>
<frame src="'||gsystem_pkg.cgi||'ggrading_pkg.stdInfoPage" name=info scrolling=yes frameborder=0>
		');
	ELSIF choice like '%Statistics%' THEN
		htp.bp('
<frame src="'||gsystem_pkg.cgi||'ggrading_pkg.listAssignments?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode=STAT" name=menu scrolling=yes frameborder=0 marginwidth=2 marginheight=2>
<frame src="'||gsystem_pkg.cgi||'ggrading_pkg.Statistics?unum='||unum||'&'||'crsTitle='||crsTitle||'" name=info scrolling=yes frameborder=0>
		');
	ELSIF choice like '%Set Options%' THEN
		htp.bp('
<frame src="'||gsystem_pkg.cgi||'gsystem_pkg.goBackPage" frameborder=0 marginwidth=2 marginheight=2>
<frame src="'||gsystem_pkg.cgi||'ggrading_pkg.gradingOptionsPage?unum='||unum||'&'||'crsTitle='||crsTitle||'"  name=menu scrolling=yes frameborder=0 marginwidth=2 marginheight=2>
		');
	END IF;
	htp.bp('		
</frameset>
<noframe>
<body bgcolor=white>
<h2>Error: You need frames for this!</h2></body></noframe>
<font size=-1><i>NPAC</i></font>
</body></html>
 	');
END gradingManipulationPage;
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--------------------------------------------------------------------
--##################################################################
-- gradingOptionsPage();
--##################################################################
PROCEDURE gradingOptionsPage(unum IN VARCHAR2,crsTitle IN VARCHAR2)
IS
	Extra VARCHAR2(3);
	avgPublish VARCHAR2(3);
	finGradePublish VARCHAR2(3);
	yes VARCHAR2(40);
	no VARCHAR2(40);
BEGIN
	SELECT	extraCredits,publishAVG,publishFGRD INTO Extra,avgPublish,finGradePublish FROM XXcoursesXX c WHERE c.courseTitle=crsTitle;
	htp.bp('
	<html> <header><title>Preferences</title></header>
	<body bgcolor=white>
<br><br><br><br>
<small><b> Please click on the light image to set the options</b></small>
<p>
<p>
<TABLE ALIGN=ABSCENTER BORDER=1 CELLSPACING=0 CELLPADDING=0 >
<TR>
<TD ROWSPAN="2" > <B><font color=blue> Include Extra Credits in the average </font></B></TD>
<TD ROWSPAN="2"><B>
	<a  href="'||gsystem_pkg.cgi||'ggrading_pkg.setOption?select_option=EXTRA_AVG&'||'unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'prefer=');
		IF Extra='YES' THEN
			htp.p('NO"><img src="'||gsystem_pkg.images||'green_light.gif" height=30 width=31  border=0></a>');
			yes:='<b>YES</b>';
			no:='<font color=gray><b>NO</b></font>';
		ELSE
			htp.p('YES"><img src="'||gsystem_pkg.images||'red_light.gif" height=32 width=31 border=0></a>');
			no:='<b>NO</b>';
			yes:='<font color=gray><b>YES</b></font>';
		END IF;
	htp.bp('
</B></TD>
<TD>'||no||'</TD>
</TR>
<TR>
<TD>'||yes||'</TD>
</TR>
<TR>
<TD ROWSPAN="2" > <B> <font color=blue> Publish Average </font></B></TD>
<TD ROWSPAN="2"><B>
	<a  href="'||gsystem_pkg.cgi||'ggrading_pkg.setOption?select_option=PUBLISH_AVG&'||'unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'prefer=');
		IF avgPublish='YES' THEN
			htp.p('NO"><img src="'||gsystem_pkg.images||'green_light.gif" height=30 width=31  border=0></a>');
			yes:='<b>YES</b>';
			no:='<font color=gray><b>NO</b></font>';
		ELSE
			htp.p('YES"><img src="'||gsystem_pkg.images||'red_light.gif" height=32 width=31 border=0></a>');
			no:='<b>NO</b>';
			yes:='<font color=gray><b>YES</b></font>';
		END IF;
	htp.bp('
</B></TD>
<TD>'||no||'</TD>
</TR>
<TR>
<TD>'||yes||'</TD>
</TR>
<TR>
<TD ROWSPAN="2" > <B><font color=blue> Publish Final Grades </font></B></TD>
<TD ROWSPAN="2"><B>
	<a  href="'||gsystem_pkg.cgi||'ggrading_pkg.setOption?select_option=PUBLISH_FINAL&'||'unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'prefer=');
		IF finGradePublish='YES' THEN
			htp.p('NO"><img src="'||gsystem_pkg.images||'green_light.gif" height=30 width=31  border=0></a>');
			yes:='<b>YES</b>';
			no:='<font color=gray><b>NO</b></font>';
		ELSE
			htp.p('YES"><img src="'||gsystem_pkg.images||'red_light.gif" height=32 width=31 border=0></a>');
			no:='<b>NO</b>';
			yes:='<font color=gray><b>YES</b></font>';
		END IF;
	htp.bp('
</B></TD>
<TD>'||no||'</TD>
</TR>
<TR>
<TD>'||yes||'</TD>
</TR>
</TABLE>
	</body></html>
 	');
	
END gradingOptionsPage;
--------------------------------------------------------------------
--##################################################################
-- setExtra
--##################################################################
PROCEDURE setOption(		select_option	IN VARCHAR2,
				unum IN VARCHAR2,	
				crsTitle IN VARCHAR2,
				prefer IN VARCHAR2)
IS
BEGIN
	IF select_option='PUBLISH_AVG' THEN
		UPDATE XXcoursesXX c SET publishAVG=prefer  WHERE c.courseTitle=crsTitle ;
	ELSIF select_option='EXTRA_AVG' THEN
		UPDATE XXcoursesXX c SET extraCredits=prefer  WHERE c.courseTitle=crsTitle ;
	ELSIF select_option='PUBLISH_FINAL' THEN
		UPDATE XXcoursesXX c SET publishFGRD=prefer  WHERE c.courseTitle=crsTitle ;
	END IF;
	COMMIT;
	gradingOptionsPage(unum,crsTitle);
END setOption;
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--------------------------------------------------------------------
--##################################################################
-- listStudent
--##################################################################
PROCEDURE listStudents(unum IN VARCHAR2,crsTitle IN VARCHAR2)
IS
	student_cur 	GenericCurType;
	std		XXstudentsXX%ROWTYPE;
	courseURL	varchar2(200);
	browser		boolean default false;
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  gsystem_pkg.accessPermit(unum,crsTitle,'grading:listStudents:Browser') THEN
		browser:=true;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	SELECT url INTO courseURL FROM XXcoursesXX WHERE courseTitle=crsTitle;
	htp.p('
<html><body bgcolor=white>
<base target=info>');
	gsystem_pkg.backGuaranteed;
	htp.bp('
<table>
<tr><td>');
	IF courseURL IS NULL THEN
		htp.bp('
<img src='||gsystem_pkg.images||'homeempty.jpg border=0 align=center> </td>	
		');
	ELSE
		htp.bp('
<a href='||courseURL||'><img src='||gsystem_pkg.images||'homefull.jpg border=0></a></td>
		');
	END IF;
	htp.p('</td>
<td><b>'||crsTitle||'</b></td></tr>
<td colspan=2><hr></td></tr>
	');
	IF NOT student_cur%ISOPEN THEN      -- open the cursor if
	            gsystem_pkg.open_cv (student_cur,'XXstudentsXX',crsTitle);    -- not open yet
        END IF;
 	-- Fetch rows into PL/SQL table
	LOOP
		FETCH student_cur INTO std;
                EXIT WHEN student_cur%NOTFOUND;
			
		IF std.url IS NULL THEN
			htp.bp('
<tr><td>
<img src='||gsystem_pkg.images||'homeempty.jpg border=0 align=center> 
</td>	
			');
		ELSE
			htp.bp('
<tr><td>
<a href='||std.url||' target=studentHome><img src='||gsystem_pkg.images||'homefull.jpg border=0 align=center></a> 
</td>
			');
		END IF;
		IF NOT browser THEN
			htp.bp('
<td><a href="'||gsystem_pkg.cgi||'ggrading_pkg.gradeAllAssignments?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode=SHOW&'||'stdID='||std.ssn ||'" ><b>'||std.firstname||' '||std.midname||' '||std.lastname||'</b></a></td></tr>
			');
		ELSE
			htp.bp('
<td><a href="'||gsystem_pkg.cgi||'ggrading_pkg.showStudentGrades?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode=SHOW&'||'stdName='||std.firstname||std.midname||std.lastname||'" ><b>'||std.firstname||' '||std.midname||' '||std.lastname||'</b></a></td></tr>
			');
		END IF;
        END LOOP;
        CLOSE student_cur;
	htp.bp('
<td colspan=2><hr></td></tr>
</table></body></html><font size=-1><i>NPAC</i></font>');
	gsystem_pkg.backGuaranteed;
	htp.p('  </body></html>
	');
END listStudents;
--------------------------------------------------------------------
--##################################################################
-- listAssignments
--##################################################################
PROCEDURE listAssignments(unum IN VARCHAR2,crsTitle IN VARCHAR2,commMode IN VARCHAR2)
IS
	assign_cur 	GenericCurType;
	ass		XXassignmentsXX%ROWTYPE;
	courseURL	varchar2(200);
BEGIN
	SELECT url INTO courseURL FROM XXcoursesXX WHERE courseTitle=crsTitle;
	htp.p('
<html><body bgcolor=white>
<base target=info>');
	gsystem_pkg.backGuaranteed;
	htp.bp('
<table>
<tr><td>');
	IF courseURL IS NULL THEN
		htp.bp('
<img src='||gsystem_pkg.images||'homeempty.jpg border=0 align=center> </td>	
		');
	ELSE
		htp.bp('
<a href='||courseURL||'><img src='||gsystem_pkg.images||'homefull.jpg border=0></a></td>
		');
	END IF;
	htp.p('</td>
<td><b>'||crsTitle||'</b></td></tr><tr><td colspan=2><hr></td></tr>
	');
	IF commMode='STAT' THEN
		htp.bp('<tr><td></td><td><a href="'||gsystem_pkg.cgi||'ggrading_pkg.updateAverages?unum='||unum||'&'||'crsTitle='||crsTitle||'"> <b> Recalculate Averages</a></tr>
		');
		htp.bp('<tr><td></td><td><a href="'||gsystem_pkg.cgi||'ggrading_pkg.OrderStudents?unum='||unum||'&'||'crsTitle='||crsTitle||'"> <b> Ranks </a></tr>
		');
		htp.bp('<tr><td></td><td><a href="'||gsystem_pkg.cgi||'ggrading_pkg.Statistics?unum='||unum||'&'||'crsTitle='||crsTitle||'"> <b> Averages</a></tr>
		');
	END IF;
	IF NOT assign_cur%ISOPEN THEN      -- open the cursor if
	            gsystem_pkg.open_cv (assign_cur,'XXassignmentsXX',crsTitle);    -- not open yet
        END IF;
 	-- Fetch rows into PL/SQL table
	LOOP
		FETCH assign_cur INTO ass;
                EXIT WHEN assign_cur%NOTFOUND;
			
		IF ass.url IS NULL THEN
			htp.bp('
<tr><td>
<img src='||gsystem_pkg.images||'homeempty.jpg border=0 align=center> 
</td>	
			');
		ELSE
			htp.bp('
<tr><td>
<a target=asgnHome href='||ass.url||'><img src='||gsystem_pkg.images||'homefull.jpg border=0 align=center></a> 
</td>
			');
		END IF;
		htp.bp('
<td><a href="'||gsystem_pkg.cgi||'ggrading_pkg.Assignment?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode='||commMode||'&'||'VassID='||ass.assID||'"><b>'||ass.typ||' '||ass.assID||'</a> 	'
		);
		IF NOT ass.commentURL IS NULL THEN
			htp.p('<a href='||ass.commentURL||' >*</a>');
		END IF;
		htp.bp('<a target=menu  href="'||gsystem_pkg.cgi||'ggrading_pkg.publishAssignment?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode='||commMode||'&'||'VassID='||ass.assID||'&'||'pub=');
		IF ass.publish='YES' THEN
			htp.p('NO"><img src="'||gsystem_pkg.images||'green_light.gif" height=30 width=31  border=0></a>');
		ELSE
			htp.p('YES"><img src="'||gsystem_pkg.images||'red_light.gif" height=32 width=31 border=0></a>');
		END IF;
		htp.p('</b></td></tr>');
        END LOOP;
        CLOSE assign_cur;
	htp.bp('
<td colspan=2><hr></td></tr>
</table></body></html><font size=-1><i>NPAC</i></font>');
	gsystem_pkg.backGuaranteed;
	htp.p('  </body></html>
	');
END listAssignments;
--------------------------------------------------------------------
--##################################################################
-- publishAssignment
--##################################################################
PROCEDURE publishAssignment(		unum IN VARCHAR2,		--*- no security -*--
						crsTitle IN VARCHAR2,
						commMode IN VARCHAR2,
						VassID IN VARCHAR2,
						pub IN VARCHAR2
						)
IS
	assign_cur 	GenericCurType;
	ass		XXassignmentsXX%ROWTYPE;
	courseURL	varchar2(200);
BEGIN
	UPDATE XXassignmentsXX a
	SET  	
		a.publish=pub
	WHERE a.course=crsTitle AND a.assID=VassID;
	COMMIT;
	listAssignments(unum,crsTitle ,commMode );
END  publishAssignment;
--##################################################################
-- STDINFOPAGE
--##################################################################
PROCEDURE STDINFOPAGE
IS
BEGIN
	htp.bp('
<html><body bgcolor=white><h2> Please click on the name of the student to grade.</h2>
<h4>Note that full colored home images goes to student`s home page,</h4>
<h5>and full colored home image before the course name goes to course home page.</h5>
</body></html>
	');
END STDINFOPAGE;
--##################################################################
-- getStdGrade(K
--##################################################################
PROCEDURE getStdGrade(stdgr OUT XXGRADESXX%ROWTYPE,Sssn IN VARCHAR2,crsTitle IN VARCHAR2,AassID IN VARCHAR2)
IS
BEGIN
	SELECT * INTO stdgr FROM XXgradesXX g WHERE g.ssn=Sssn AND g.course=crsTitle AND g.assid=AassID;
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		stdgr.grade:='__'; -- not graded
END getStdGrade;
--------------------------------------------------------------------
--##################################################################
-- getPerformance(crsTitle IN VARCHAR2,stdID IN VARCHAR2,prf OUT XXperformanceXX%ROWTYPE)
--##################################################################
PROCEDURE getPerformance(crsTitle IN VARCHAR2,stdID IN VARCHAR2,prf OUT XXperformanceXX%ROWTYPE)
IS
BEGIN
	IF NOT (stdID IS NULL) THEN
		SELECT * INTO prf FROM XXperformanceXX s WHERE s.ssn=stdID AND s.course=crsTitle;
	ELSE
		gsystem_pkg.printErrorPage('Null student id passed!.Please report to msen7@npac');
	END IF;
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		NULL;
END ;
--------------------------------------------------------------------
--##################################################################
-- selectStudent(crsTitle IN VARCHAR2,stdID IN VARCHAR2,std OUT XXstudentSXX%ROWTYPE)
--##################################################################
FUNCTION  selectStudent(crsTitle IN VARCHAR2,stdID IN VARCHAR2,std OUT XXstudentsXX%ROWTYPE) RETURN BOOLEAN
IS
BEGIN
	IF NOT (stdID IS NULL) THEN
		SELECT * INTO std FROM XXstudentsXX s WHERE s.ssn=stdID AND s.course=crsTitle;
	ELSE
		gsystem_pkg.printErrorPage('Null student id passed!.Please report to <a href="mailto:msen@npac.syr.edu">msen7@npac</a>');
	END IF;
	RETURN TRUE;
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		gsystem_pkg.printErrorPage('Student does not exist in the database. System internal errorcode #g111, please report to <a href="mailto:msen@npac.syr.edu">msen7@npac</a><br>');
		RETURN FALSE;
END ;
--------------------------------------------------------------------
--##################################################################
-- gradeAllAssignments
--##################################################################
PROCEDURE gradeAllAssignments(unum IN VARCHAR2,crsTitle IN VARCHAR2,commMode IN VARCHAR2, stdID IN VARCHAR2)
IS
	ass		XXassignmentsXX%ROWTYPE;
	grade_cur 	GenericCurType;
	agrade		XXgrade_customizeXX%ROWTYPE;
	grades		VARCHAR2(1000);
	sgrades		VARCHAR2(1000);
	gradeType 	VARCHAR2(100);
	assign_cur 	GenericCurType;
	std		XXstudentsXX%ROWTYPE;
	prf		XXperformanceXX%ROWTYPE;
	email		VARCHAR2(10);
	htmlgrades	VARCHAR2(30000);
	stdgr 		 XXGRADESXX%ROWTYPE;
	gA	VARCHAR2(5);  gE	VARCHAR2(5);gC	VARCHAR2(5);gT	VARCHAR2(5);gG	VARCHAR2(5);gI	VARCHAR2(5);gW	VARCHAR2(5);gP	VARCHAR2(5);
	acounter 	Number(2) DEFAULT 0;
	aurls  VARCHAR2(300);
BEGIN
--	-------gsystem_pkg.getPrivateDataPermission(uname,crsTitle,gsystem_pkg.CO_INSTRUCTOR,'
--	IF gsystem_pkg.accessPermit(unum,crsTitle,'grading:secretremarks') THEN
--		htp.p('this.document.G.sremark.value+"{[srm]}"+');
--	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'grading:gradeAllAssignments') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF NOT selectStudent(crsTitle,stdID,std) THEN RETURN ;
	END IF;
	getPerformance(crsTitle,stdID,prf);
	IF NOT std.email IS NULL THEN email:='(e-mail)'; ELSE email:=NULL; END IF;
	htp.bp('
<html><script language="JavaScript">
function updateDB(){
	var results=');
	IF NOT assign_cur%ISOPEN THEN      -- open the cursor if
	            gsystem_pkg.open_cv (assign_cur,'XXassignmentsXX',crsTitle);    -- not open yet
        END IF;
 	-- Fetch rows into PL/SQL table
	LOOP
		FETCH assign_cur INTO ass;
                EXIT WHEN assign_cur%NOTFOUND;
		getStdGrade(stdgr,std.ssn,crsTitle,ass.assID);
		IF NOT stdgr.grade= '__' THEN
			acounter:=acounter+1;
		END IF;
		gI:='I'||ass.assID;
		gA:='A'||ass.assID;
		gE:='E'||ass.assID;
		gC:='C'||ass.assID;
		gT:='T'||ass.assID;	
		gG:='G'||ass.assID;	
		gW:='W'||ass.assID;	
		gP:='P'||ass.assID;	
		SELECT	assType INTO gradeType FROM XXcoursesXX c WHERE c.courseTitle=crsTitle;
--		******************************
		IF gradeType='customized' THEN
			grades:='';
			sgrades:='';
			IF NOT grade_cur%ISOPEN THEN      -- open the cursor if
	            		gsystem_pkg.open_cv (grade_cur,'XXgrade_customizeXX',crsTitle);    -- not open yet
	      		  END IF;
	 		-- Fetch rows into PL/SQL table
			LOOP
				FETCH grade_cur INTO agrade;
      		   	     EXIT WHEN grade_cur%NOTFOUND;
				IF ass.gBase= agrade.grade THEN
					grades:=grades||'<option value='||agrade.grade||' SELECTED>'||agrade.grade;	
				ELSE
					grades:=grades||'<option value='||agrade.grade||'>'||agrade.grade;
				END IF;
				IF stdgr.grade= agrade.grade THEN
					sgrades:=sgrades||'<option value='||agrade.grade||' SELECTED>'||agrade.grade;
				ELSE
					sgrades:=sgrades||'<option value='||agrade.grade||'>'||agrade.grade;
				END IF;
	        	END LOOP;
        		CLOSE grade_cur;
			IF stdgr.grade= '__' THEN
				sgrades:=sgrades||'<option value='||stdgr.grade||' SELECTED>'||stdgr.grade;
			END IF;
			grades:='<TD><select name='||gG||'>'||grades||'</select></TD>';
			sgrades:='<TD><select name='||gA||'>'||sgrades||'</select></TD>';
		ELSE 
			IF stdgr.grade= '__' THEN stdgr.grade:=NULL;
			END IF;
			grades:='<TD><input name='||gG||'	 size=3 value="'|| ass.gBase||'"></TD>';
			sgrades:='<TD><input name='||gA||'	 size=3 value="'|| stdgr.grade||'"></TD>';
		END IF;
--		******************************
		IF NOT ass.url IS NULL THEN
			aurls:='<a href='||ass.url||'>'||substr(ass.typ,0,1)||TO_CHAR(ass.assID)||'</a>';
		ELSE aurls:=substr(ass.typ,0,1)||TO_CHAR(ass.assID);
		END IF;
		IF NOT ass.commentURL IS NULL THEN
			aurls:=aurls||'</a><a href='|| ass.commentURL ||'> *</a>';
		END IF;
--
		htmlgrades:=htmlgrades||'
<TR><TD ALIGN=CENTER><b>'||aurls||'<input type=hidden name='||gI||' value="'||TO_CHAR(ass.assID)||'"></TD>
'|| sgrades||'
<TD><input name='||gE||' size=2 value="'|| stdgr.egrade||'"></TD>
'|| grades||'
<TD><input name='||gW||'  size=2 value="'|| TO_CHAR(ass.weight)||'"><b>%</TD>
<TD><input name='||gP||' size=8 value="'|| stdgr.partials ||'"></TD>
<TD><input name='||gC||' size=30 value="'|| stdgr.comm||'"></TD>
<TD><input name='||gT||' size=30 value="'|| stdgr.tacomm||'"></TD>
</TR>	
		';
	--	js:=js||'this.document.
		htp.p('this.document.G.'||gI||'.value+"{~}"+');
		IF gradeType='customized' THEN
			htp.p('this.document.G.'||gA||'.options[this.document.G.'||gA||'.selectedIndex].text+"{~}"+');
			htp.p('this.document.G.'||gG||'.options[this.document.G.'||gG||'.selectedIndex].text+"{~}"+');
		ELSE
			htp.p('this.document.G.'||gA||'.value+"{~}"+');
			htp.p('this.document.G.'||gG||'.value+"{~}"+');
		END IF;
		htp.p('this.document.G.'||gE||'.value+"{~}"+');
		htp.p('this.document.G.'||gW||'.value+"{~}"+');
		htp.p('this.document.G.'||gP||'.value+"{~}"+');		
		htp.p('this.document.G.'||gC||'.value+"{~}"+');
		htp.p('this.document.G.'||gT||'.value+"{[~]}"+');
        END LOOP;
        CLOSE assign_cur;
-------------------------------------------------------------------------------------------------------
	htp.p('"'||prf.average||'{[a]}"+');
	htp.p('this.document.G.fgrade.value+"{[fg]}"+');
	htp.p('this.document.G.remark.value+"{[rm]}"+');
	htp.p('this.document.G.taremark.value+"{[trm]}"+');
	IF gsystem_pkg.accessPermit(unum,crsTitle,'grading:secretremarks') THEN
		htp.p('this.document.G.sremark.value+"{[srm]}"+');
	END IF;
	htp.bp('"";
	this.document.secret.jsraw.value=results;
	this.document.secret.submit();
}
var acounter='||TO_CHAR(acounter)||';
</script>
<body bgcolor=white>
<form action="" name="G" method=POST>
<table><tr><td bgcolor=red><font color=white size=+1 FACE="Arial, Helvetica" ><b>
<input type=button value=" UPDATE " onClick="updateDB();"></b></font></td>
<td bgcolor=green><font color=white size=+1 FACE="Arial, Helvetica"><b>
<input type=reset  value=" UNDO "></b></font></td>
</tr>
</table>
<font size=+2> '||INITCAP(std.firstname)||' '||INITCAP(std.midname)||' '||INITCAP(std.lastname)||' <font size=+1> <a HREF="mailto:'||std.email||'">'||email||'</a>,<i> '|| std.class||' in the department of '|| INITCAP(std.dept) ||'</i> </font></h2>
<TABLE bgcolor="#ff99ff" ALIGN=ABSCENTER BORDER=0 CELLSPACING=0 CELLPADDING=0 >
<tr><td colspan=8><hr></td></tr>
<TR>
<TD  bgcolor=#ffFFcc> <FONT FACE="Arial,Helvetica" COLOR=red><B>HW_#</B></FONT></TD>
<TD  bgcolor=#ccFFcc> <FONT FACE="Arial,Helvetica" COLOR=red><center><B>Grade</B></FONT></TD>
<TD  bgcolor=#ffFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red><B>Extra CR</B></FONT></TD>
<TD  bgcolor=#ccFFcc> <FONT FACE="Arial,Helvetica" COLOR=red><center><B>Grading Base</B></FONT></TD>
<TD  bgcolor=#ffFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red ><B>Weight</B></FONT></TD>
<TD  bgcolor=#ffFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red ><center><B>Partials</B></FONT></TD>
<TD  bgcolor=#ccFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red ><center><B>Comments</B></FONT></TD>
<TD  bgcolor=#ffFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red><B>TA Comments </b><font color=green size=-1> (secret)</B></FONT></TD>
</TR>
<tr><td colspan=8><hr></td></tr>
'||htmlgrades); htp.bp('
<tr><td colspan=8><hr></td></tr>
</table>
<Hr><table>
<TR><TD ALIGN=CENTER bgcolor=pink>Average </TD>
<TD ALIGN=CENTER bgcolor=pink></TD>
<TD bgcolor=pink>'||prf.average||'</TD>
<TD bgcolor=pink>Averages are from <font color=red size=+1><b>'||TO_CHAR(acounter)||'</font></b> assignments and each assignment is counted based on the weight of grading base.</TD>
</TR>
<tr><td colspan=5><hr></td></tr>
<tr>
<td><font color=red><b> Final Grade</b> </font></td> <td><input name=fgrade size=3 value="'||prf.grade||'"></TD>
<td align=right>Remarks: </td>
<td><textarea name=remark cols=30 rows=3>'||prf.Public_remark||'</textarea></TD>
</tr>
<tr>
<td></td>
<td></TD>
<td align=right>TA Secret Remarks: </td>
<td><textarea name=taremark cols=30 rows=3>'||prf.ta_remark||'</textarea></TD>
</tr>
	');
	IF gsystem_pkg.accessPermit(unum,crsTitle,'grading:secretremarks') THEN
		htp.bp('
<tr>
<td></td>
<td></TD>
<td align=right>Instructor Secret Remarks: </td>
<td><textarea name=sremark cols=30 rows=3>'||prf.secret_remark||'</textarea></TD>
</tr>
		');
	END IF;
	htp.bp('
</table><br>
</form>
<font size=-1><i>NPAC</i></font>
<form action='||gsystem_pkg.cgi||'ggrading_pkg.commandServer
name=secret
method="POST">
<input type=hidden name=unum  value="'||unum||'"> 
<input type=hidden name=crsTitle  value="'||crsTitle||'"> 
<input type=hidden name=request  value="UPDATE"> 
<input type=hidden name=stdID  value="'||stdID||'"> 
<input type=hidden name=jsraw value=""> 
</form>
 </body></html>
		');
END gradeAllAssignments;
--------------------------------------------------------------------
--##################################################################
-- gradeAssignment
--##################################################################
PROCEDURE gradeAssignment(unum IN VARCHAR2,crsTitle IN VARCHAR2, VassID IN NUMBER)
IS
	ass		XXassignmentsXX%ROWTYPE;
	grade_cur 	GenericCurType;
	agrade		XXgrade_customizeXX%ROWTYPE;
	grades		VARCHAR2(1000);
	sgrades		VARCHAR2(1000);
	gradeType 	VARCHAR2(100);
	student_cur 	GenericCurType;
	std		XXstudentsXX%ROWTYPE;
	email		VARCHAR2(10);
	stdgr 		 XXGRADESXX%ROWTYPE;
	aurls  VARCHAR2(300);
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'grading:gradeAssignment') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
--- html grading --header-------------
	htp.bp('
<html>
<script language ="JavaScript">
function setAllGB(setthis){
	for (var i=0; i< document.forms.length;i++)
	 document.forms[i].GB.value=setthis;
}
function selectAllGB(ind){
	for (var i=0; i< document.forms.length;i++)
	 document.forms[i].GB.options.selectedIndex=ind;
}
function setAllW(setthis){
	for (var i=0; i< document.forms.length;i++)
	 document.forms[i].W.value=setthis;
}
</script>
<body bgcolor=white>
		');
---html end ---------------------------
	SELECT	assType INTO gradeType FROM XXcoursesXX c WHERE c.courseTitle=crsTitle;
	SELECT  *  INTO ass FROM xxassignmentsxx a WHERE a.course=crsTitle AND a.assID=VassID;
	IF NOT student_cur%ISOPEN THEN      -- open the cursor if
	            gsystem_pkg.open_cv (student_cur,'XXstudentsXX',crsTitle);    -- not open yet
        END IF;
 	-- Fetch rows into PL/SQL table
	LOOP
		FETCH student_cur INTO std;
                EXIT WHEN student_cur%NOTFOUND;
		getStdGrade(stdgr,std.ssn,crsTitle,VassID);
--		******************************
		IF gradeType='customized' THEN
			grades:='';
			sgrades:='';
			IF NOT grade_cur%ISOPEN THEN      -- open the cursor if
	            		gsystem_pkg.open_cv (grade_cur,'XXgrade_customizeXX',crsTitle); 
	      		  END IF;
	 		-- Fetch rows into PL/SQL table
			LOOP
				FETCH grade_cur INTO agrade;
      		   	     	EXIT WHEN grade_cur%NOTFOUND;
				IF ass.gBase= agrade.grade THEN
					grades:=grades||'<option value='||agrade.grade||' SELECTED>'||agrade.grade;	
				ELSE
					grades:=grades||'<option value='||agrade.grade||'>'||agrade.grade;
				END IF;
				IF stdgr.grade= agrade.grade THEN
					sgrades:=sgrades||'<option value='||agrade.grade||' SELECTED>'||agrade.grade;
				ELSE
					sgrades:=sgrades||'<option value='||agrade.grade||'>'||agrade.grade;
				END IF;
	        	END LOOP;
        		CLOSE grade_cur;
			IF stdgr.grade= '__' THEN
				sgrades:=sgrades||'<option value='||stdgr.grade||' SELECTED>'||stdgr.grade;
			END IF;
			grades:='<TD><select name=GB onChange="selectAllGB(this.form.GB.options.selectedIndex)">'||grades||'</select></TD>';
			sgrades:='<TD><select name=G>'||sgrades||'</select></TD>';
		ELSE 
			IF stdgr.grade= '__' THEN stdgr.grade:=NULL;
			END IF;
			grades:='<TD><input name=GB size=3 value="'|| ass.gBase||'" onChange="setAllGB(this.form.GB.value)"></TD>';
			sgrades:='<TD><input name=G size=3 value="'|| stdgr.grade||'"></TD>';
		END IF;
--		******************************
		IF NOT ass.url IS NULL THEN
			aurls:=' <a href='|| ass.url ||'>'|| TO_CHAR(ass.assID) || '</a>';
		ELSE aurls:=' ' || TO_CHAR(ass.assID);
		END IF;
		IF NOT ass.commentURL IS NULL THEN
			aurls:= aurls|| ' <a href='|| ass.commentURL ||'> *</a>';
		END IF;
--		IF NOT ass.url IS NULL THEN
--			aurls:='</a>';
--		END IF;
--		IF NOT ass.commentURL IS NULL THEN
--			aurls:='</a><a href='|| ass.commentURL ||'> *</a>';
--		END IF;
------------------------html student tables
		htp.bp('
<font size=+2> '||INITCAP(std.firstname)||' '||INITCAP(std.midname)||' '||INITCAP(std.lastname)||' <font size=+1> <a HREF="mailto:'||std.email||'">'||email||'</a><i>, '||  std.class ||' in the department of '|| INITCAP(std.dept) ||'</i></font>
<form action="'||gsystem_pkg.cgi||'ggrading_pkg.commandServer" name="G" method=get target=results>
<input type=hidden name=unum  value="'||unum||'"> 
<input type=hidden name=crsTitle  value="'||crsTitle||'"> 
<input type=hidden name=request  value="UPDATE"> 
<input type=hidden name=stdID  value="'||std.ssn||'"> 
<table><tr><td bgcolor=red><font color=white size=+1 FACE="Arial, Helvetica" ><b>
<input type=button value=" UPDATE " onClick="this.form.submit()"></b></font></td>
<td bgcolor=green><font color=white size=+1 FACE="Arial, Helvetica"><b>
<input type=reset  value=" UNDO "></b></font></td>
</tr>
</table>
<TABLE bgcolor="#ff99ff"  ALIGN=ABSCENTER BORDER=0 CELLSPACING=0 CELLPADDING=0 ><TR>
<TD  bgcolor=#ffFFcc width=40> <FONT FACE="Arial,Helvetica"  COLOR=red><B>HW#</B></FONT></TD>
<TD  bgcolor=#ccFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red><B>Grade</B></FONT></TD>
<TD  bgcolor=#ffFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red><B>Extra CR</B></FONT></TD>
<TD  bgcolor=#ccFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red ><B>Grading Base</B></FONT></TD>
<TD  bgcolor=#ffFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red ><B>Weight</B></FONT></TD>
<TD  bgcolor=#ffFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red ><center><B>Partials</B></FONT></TD>
<TD  bgcolor=#ccFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red ><center><B>Comments</B></FONT></TD>
<TD  bgcolor=#ffFFcc> <FONT FACE="Arial,Helvetica"  COLOR=red><B>TA Comments </b><font color=green size=-1> (secret)</B></FONT></TD>
</TR>
<TR><TD ALIGN=CENTER>
<b>'||aurls||'<input type=hidden name=AI value="'||TO_CHAR(ass.assID)||'"></TD>
'|| sgrades||'
<TD><input name=E size=2 value="'|| stdgr.egrade||'"></TD>
'|| grades||'
<TD><input name=W  size=2 value="'|| TO_CHAR(ass.weight)||'" onChange="setAllW(this.form.W.value)"><b>%</TD>
<TD><input name=P size=8 value="'|| stdgr.partials ||'"></TD>
<TD><input name=C size=30 value="'|| stdgr.comm||'"></TD>
<TD><input name=Tc size=30 value="'|| stdgr.tacomm||'"></TD>
</TR>	
</table><br></form><hr>
		');
------------<hr>-------------------------------------------------------------------------------------------
        END LOOP;
        CLOSE student_cur;
-------------------------------------------------------------------------------------------------------
		htp.bp('
<font size=-1><i>NPAC</i></font>
 </body></html>
		');
END gradeAssignment;
/*_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_SQL OPERATIONS on DATABASE/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_ COMMAND SERVER are below/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/*/
--------------------------------------------------------------------
--##################################################################
-- deleteGrade(crsTitle,ssn);
--##################################################################
PROCEDURE deleteGrade(VcrsTitle IN VARCHAR2,VstdID IN VARCHAR2,Vassid IN NUMBER)
IS
BEGIN
	DELETE FROM XXgradesXX g
	WHERE g.course=VcrsTitle AND g.ssn=VstdID AND g.assid=Vassid;
	COMMIT;
	IF SQL%NOTFOUND THEN
		gsystem_pkg.printErrorPage('System failed to delete grade!<br>');
	END IF;
END deleteGrade;
--------------------------------------------------------------------
--##################################################################
-- convertNumeric
--##################################################################
FUNCTION ToNumeric(wordGrade IN VARCHAR2, crsTitle IN VARCHAR2) RETURN NUMBER
IS
	numericGrade	NUMBER(3);
BEGIN
	SELECT numeric INTO numericGrade FROM XXGRADE_CUSTOMIZEXX gc
		WHERE   crsTitle=gc.course AND gc.grade=wordGrade;	
	RETURN numericGrade;
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
--		IF wordGrade like '%%%' THEN
--			RETURN TO_NUMBER(SUBSTR(wordGrade,1));
--		END IF;
		RETURN NULL;
END ToNumeric;
--##################################################################
-- getAssInfo(crsTitle,grd.assID,ass);
--##################################################################
PROCEDURE getAssInfo(crsTitle IN VARCHAR2,AassID IN NUMBER,ass IN OUT  XXassignmentsXX%ROWTYPE)
IS
BEGIN
	SELECT * INTO ass FROM XXassignmentsXX a WHERE a.course=crsTitle AND a.assid=AassID;
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		gsystem_pkg.printErrorPage('Internal error occured by calculating average.');	
END getAssInfo;
--------------------------------------------------------------------
--##################################################################
-- 
--##################################################################
FUNCTION getMaxGrade(crsTitle IN VARCHAR2,mb IN OUt VARCHAR2) RETURN NUMBER
IS
	numericGrade	NUMBER(3) DEFAULT 100;
BEGIN
	SELECT Max(numeric) INTO numericGrade FROM XXGRADE_CUSTOMIZEXX gc
		WHERE   crsTitle=gc.course;	
	SELECT  grade INTO mb FROM XXGRADE_CUSTOMIZEXX gc
		WHERE   crsTitle=gc.course AND gc.numeric=numericGrade ;	
	RETURN numericGrade;
	EXCEPTION
		WHEN  NO_DATA_FOUND THEN 
			mb :='100';
			RETURN 100;
END getMaxGrade;
--------------------------------------------------------------------
--##################################################################
-- calculateAverage(crsTitle,stdID);
--##################################################################
FUNCTION calculateAverage(crsTitle IN VARCHAR2,stdID IN VARCHAR2, publics BOOLEAN) RETURN VARCHAR2
IS
	ass		XXassignmentsXX%ROWTYPE;
	grd		XXgradesXX%ROWTYPE;
	gradeType 	VARCHAR2(100);
	includeExtra	VARCHAR2(3);
	grades_cur 	GenericCurType;
	std		XXstudentsXX%ROWTYPE;
	acounter 	Number(2) DEFAULT 0;
	WEIGHTED	BOOLEAN DEFAULT false;	
	NullWEIGHTED	BOOLEAN DEFAULT false;
	average		Number(8,5) DEFAULT 0;
	custAverage     Number(8,2) DEFAULT 0;
	roundAverage	Number(3) ;
	gradedWeight	Number(5,2) DEFAULT 0;
	averageStr	VARCHAR2(20);
	agrade		Number(8,5)	DEFAULT NULL;
	gbase		Number(3)	DEFAULT NULL;
	maxNumeric	Number(3);
	maxBase		VARCHAR2(20);
BEGIN
	SELECT	assType,extraCredits INTO gradeType,includeExtra FROM XXcoursesXX c WHERE c.courseTitle=crsTitle;
	IF gradeType='customized' THEN
		maxNumeric:=getMaxGrade(crsTitle,maxBase);
	ELSE maxNumeric:=100; maxBase:='100';
	END IF;
	--SELECT * INTO std FROM XXstudentsXX where stdID=ssn AND crsTitle=course;
	--selectStudent(crsTitle,stdID,std);
	IF NOT grades_cur%ISOPEN THEN      -- open the cursor if
		OPEN grades_cur FOR 
  			SELECT * FROM XXgradesXX
			WHERE   crsTitle=course AND stdID=ssn;
        END IF;
 	-- Fetch rows into PL/SQL table
	LOOP
	<<next_grade>>
		FETCH grades_cur INTO grd;
                EXIT WHEN grades_cur%NOTFOUND;
		getAssInfo(crsTitle,grd.assID,ass);
		IF ass.publish='NO' AND publics THEN
			GOTO next_grade;
		END IF;
		IF gradeType='customized' THEN
			gbase:=ToNumeric(ass.gBase, crsTitle);
			agrade:=ToNumeric(grd.grade, crsTitle);
		ELSE 
			gbase:=TO_NUMBER(ass.gBase);
			agrade:=1*TO_NUMBER(grd.grade);
		END IF;
		IF includeExtra='YES' AND grd.egrade IS NOT NULL THEN
			IF gradeType='customized' THEN
				agrade:= agrade+ToNumeric(grd.egrade, crsTitle);
			ELSE
				agrade:= agrade+TO_NUMBER(grd.egrade);
			END IF;
		END IF;
--		******************************
		IF NOT agrade IS NULL THEN
			IF NOT gbase IS NULL AND NOT gbase=0 THEN
				agrade:=(agrade*maxNumeric)/gbase;
			END IF;
			IF NOT ass.weight IS NULL THEN
				agrade:=agrade*ass.weight/100;
				gradedWeight:=gradedWeight+ass.weight;
				WEIGHTED:=true;
				IF NullWEIGHTED THEN
					RETURN 'Not Applicaple';
				END IF;
			ELSE
				NullWEIGHTED:=TRUE;
				IF WEIGHTED THEN
					RETURN 'Not Applicaple';
				END IF;
			END IF;
		ELSE
			IF grd.grade IS NULL OR grd.grade='__' THEN
				deleteGrade(grd.course,grd.ssn,grd.assid);
				GOTO next_grade;
			ELSE
				RETURN 'Not Applicaple';
			END IF;		
		END IF;
--		******************************
--htp.p('<h2>'||agrade||' av '||average||' maxNum' ||maxNumeric||'gradedWeight  '||gradedWeight); 
		average :=average+agrade;
		acounter:=acounter+1;
        END LOOP;
        CLOSE grades_cur;
	IF acounter=0 THEN
		RETURN 'NAP';
	END IF;
	IF NOT WEIGHTED THEN
		average:=average/acounter;
	ELSE
		average:=average*100/gradedWeight;
	END IF;
	IF gradeType='customized' THEN
		roundAverage:=average*100;
		SELECT MAX(numeric) INTO average  FROM XXGRADE_CUSTOMIZEXX gc
    				WHERE   crsTitle=gc.course AND gc.numeric <=average ;
		SELECT grade INTO averageStr  FROM XXGRADE_CUSTOMIZEXX gc
    				WHERE   crsTitle=gc.course AND gc.numeric =average ;
		IF (UPPER(averageStr)='ABSENT' OR UPPER(averageStr)='PRESENT' ) THEN
			averageStr:='%'||TO_CHAR(roundAverage);
		END IF;
	ELSE
		roundAverage:=average;
		averageStr:=	TO_CHAR(roundAverage);
	END IF;
	--averageStr:=averageStr||'/'||maxBase;
	RETURN averageStr;
END calculateAverage;
--------------------------------------------------------------------
--##################################################################
-- updateAverages
--##################################################################
PROCEDURE updateAverages(unum IN vARCHAR2,crsTitle IN VARCHAR2) 
IS
	std	XXstudentsXX%ROWTYPE;
	av VARCHAR2(20);
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'grading:gradeAllAssignments') THEN
		RETURN ;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	FOR std IN (SELECT *  FROM XXstudentsXX s WHERE  s.course=crsTitle) LOOP
		av:=calculateAverage(crsTitle,std.ssn,false);
		UPDATE XXperformanceXX p SET average=av  WHERE p.course=crsTitle AND p.ssn=std.ssn ;
		COMMIT;
	END LOOP;
	
	htp.bp('<html> All the averages in the class recalculated</html>');
END updateAverages;
--------------------------------------------------------------------
--##################################################################
-- selectStudent(crsTitle IN VARCHAR2,stdID IN VARCHAR2,std OUT XXstudentSXX%ROWTYPE)
--##################################################################
FUNCTION  selectStudentByName(crsTitle IN VARCHAR2,stdName IN VARCHAR2,std OUT XXstudentsXX%ROWTYPE) RETURN BOOLEAN
IS
BEGIN
	IF NOT (stdName IS NULL) THEN
		SELECT * INTO std FROM XXstudentsXX s WHERE s.firstname||s.midname||s.lastname=stdName AND s.course=crsTitle;
	ELSE
		gsystem_pkg.printErrorPage('Null student id passed!.Please report to <a href="mailto:msen@npac.syr.edu">msen7@npac</a>');
	END IF;
	RETURN TRUE;
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		gsystem_pkg.printErrorPage('Student does not exist in the database. System internal errorcode #g111, please report to <a href="mailto:msen@npac.syr.edu">msen7@npac</a><br>');
		RETURN FALSE;
END ;
--------------------------------------------------------------------
--##################################################################
-- showGrades(unum,course,stdID);
--##################################################################
PROCEDURE showGrades(unum IN VARCHAR2, crsTitle IN VARCHAR2,stdID IN VARCHAR2,clock IN VARCHAR2)
IS
	ass		XXassignmentsXX%ROWTYPE;
	grade_cur 	GenericCurType;
	assign_cur 	GenericCurType;
	std		XXstudentsXX%ROWTYPE;
	prf		XXperformanceXX%ROWTYPE;
	tafield		VARCHAR2(10000);
	taAccess	BOOLEAN DEFAULT false;
	stdgr 		 XXGRADESXX%ROWTYPE;
	aid		  VARCHAR2(300);
	acounter 	Number(2) DEFAULT 0;
	avgstr		VARCHAR2(50) DEFAULT 'based on the weight of the assignment.';
	averagePublish  VARCHAR2(3);
	finGradePublish VARCHAR2(3);
BEGIN
	SELECT	publishAVG,publishFGRD INTO averagePublish,finGradePublish FROM XXcoursesXX c WHERE c.courseTitle=crsTitle;
	IF NOT selectStudent(crsTitle,stdID,std) THEN
		RETURN;
	END IF;
	getPerformance(crsTitle,stdID,prf);
--	SELECT * INTO std FROM XXstudentsXX where stdID=ssn AND crsTitle=course;
--	SELECT * INTO prf FROM XXperformanceXX where stdID=ssn AND crsTitle=course;
	IF gsystem_pkg.accessPermit(unum,crsTitle,'grading:taremarks') THEN
		taAccess:= true		;
		tafield:='<TD BGCOLOR=white> <FONT  COLOR=red><B>TA Secret Comments</B></FONT></TD>';
	END IF;
----------------------------------------html--BEGIN--------header-----------------------
	htp.bp('
<HTML>
<HEAD>
<title>Course Grades Access </title>
</HEAD>
<body background ='||gsystem_pkg.images||'query.gif>
<h1>'|| crsTitle ||' Grades Access    </H1> 
<BR>
<TABLE ALIGN=ABSCENTER BORDER=5 CELLSPACING=6 CELLPADDING=6 >
<TR><TD BGCOLOR=cornsilk><ABSCENTER>
<h2><FONT COLOR=deeppink> '||INITCAP(std.firstname)||' '||INITCAP(std.midname)||' '||INITCAP(std.lastname) ||',
<FONT SIZE=+1> <i> '||std.class || '   in the department of '||INITCAP(std.dept)||'</FONT></i>
</FONT></h2>
</ABSCENTER></TD></TR>
</TABLE>
<BR>
<TABLE ALIGN=ABSCENTER BORDER=5 CELLSPACING=6 CELLPADDING=6 >
<TR>
<TD BGCOLOR=white> <FONT  FACE="Arial,Helvetica" COLOR=red><B>Assign #</B></FONT></TD>
<TD BGCOLOR=white> <FONT  FACE="Arial,Helvetica" COLOR=red><B>Grade</B></FONT></TD>
<TD BGCOLOR=white> <FONT  FACE="Arial,Helvetica" COLOR=red><B>Extra CR</B></FONT></TD>
<TD BGCOLOR=white> <FONT   FACE="Arial,Helvetica" COLOR=red ><B>GradingBase</B></FONT></TD>
<TD BGCOLOR=white> <FONT  FACE="Arial,Helvetica" COLOR=red><B>Weight %</B></FONT></TD>
<TD BGCOLOR=white> <FONT   FACE="Arial,Helvetica" COLOR=red><B>Partial Comments</B></FONT></TD>
<TD BGCOLOR=white> <FONT  FACE="Arial,Helvetica"  COLOR=red><B>Comments</B></FONT></TD>
'||tafield||'
</TR>
	');
----------------------------------------html--END------------------------------
	IF NOT assign_cur%ISOPEN THEN      -- open the cursor if
		gsystem_pkg.open_cv (assign_cur,'XXassignmentsXX',crsTitle);    -- not open yet
        END IF;
 	-- Fetch rows into PL/SQL table
	LOOP
	<<continue>>
		FETCH assign_cur INTO ass;
                EXIT WHEN assign_cur%NOTFOUND;
		IF  ass.Typ='zAverage' THEN
--			IF ass.publish='NO' THEN
--				averagePublish:=False; --default true
--			END IF;
			GOTO continue;
		END IF;
		IF ass.publish='NO'  THEN
			GOTO continue;
		END IF;
		getStdGrade(stdgr,std.ssn,crsTitle,ass.assID);
		IF  stdgr.grade= '__' THEN
			stdgr.grade:='NG';
			stdgr.comm :='Not Graded Yet';
		ELSE 	
			acounter:=acounter+1;
		END IF;
		IF NOT ass.url IS NULL THEN
			aid:=' <a href='|| ass.url ||'>'|| TO_CHAR(ass.assID) || '</a>';
		ELSE aid:=' ' || TO_CHAR(ass.assID);
		END IF;
		IF NOT ass.commentURL IS NULL THEN
			aid:= aid || ' <a href='|| ass.commentURL ||'> *</a>';
		END IF;
		tafield:='';
		IF taAccess THEN
			tafield:='<TD BGCOLOR="#FF99FF" >'|| stdgr.tacomm ||'</TD>';
		END IF;
		IF ass.weight IS NULL THEN
			avgstr:='in equal weights.';
		END IF;
----------------------------html----BEGIN assignment----------------------------
		htp.bp('
<TR>
<TD><CENTER><B> '||ass.typ||aid||'</B></CENTER>  </TD>
<TD BGCOLOR=pink>'||stdgr.grade||'</TD>
<TD>'||stdgr.egrade ||'</TD>
<TD>'||ass.gBase ||'</TD>
<TD>'||TO_CHAR(ass.weight) ||'</TD>
<TD>'||stdgr.partials ||'</TD>
<TD BGCOLOR=beige>'|| stdgr.comm ||'</TD>
'||tafield||'
</TR>
			');
----------------------------------------html--END------------------------------
        END LOOP;
        CLOSE assign_cur;
----------------------------html----BEGIN std info----------------------------
	htp.bp('
</table>
<Hr><table>
');
	IF ( averagePublish='YES') THEN
		htp.bp('
<TR><TD ALIGN=CENTER bgcolor=pink>Average </TD>
<TD ALIGN=CENTER bgcolor=pink></TD>
<TD bgcolor=pink>'|| 
calculateAverage(crsTitle,stdID,true)
-- prf.average
||'</TD>
<TD bgcolor=pink>Averages are from '||TO_CHAR(acounter)||' homeworks and each homework is counted '||avgstr ||'</TD>
</TR>
		');
	END IF;
	htp.bp('
<tr><td colspan=5><hr></td></tr>
<tr>
<td bgcolor=white><font color=red><b> Final Grade</b> </font></td> <td bgcolor=white ><font color=red size=+2><b>');
	IF ( finGradePublish='YES') THEN
		htp.bp(prf.grade);
	END IF;
	htp.bp('</TD>
<td align=right><b>Remarks: </td>
<td bgcolor=#ffff99>'||prf.Public_remark||'</TD>
</tr>
			');
	IF taAccess THEN
		htp.bp('
<tr>
<td></td>
<td></TD>
<td align=right ><b>TA Secret Remarks: </td>
<td bgcolor=#ffcc99>'||prf.ta_remark||'</TD>
</tr>
		');
	END IF;
	IF gsystem_pkg.accessPermit(unum,crsTitle,'grading:secretremarks') THEN
		htp.bp('
<tr>
<td></td>
<td></TD>
<td align=right><b>Instructor Secret Remarks: </td>
<td bgcolor=#ff9999>'||prf.secret_remark||'</TD>
</tr>
		');
	END IF;
	htp.bp('
</table><br>');
	gsystem_pkg.back;
	IF NOT clock='DO NOT PUT TIME-OUT' THEN
		htp.p('	<DIV ALIGN=right>');
		gsystem_pkg.insert_shut_off_scripts(2,0);
	END IF;
		htp.bp('</body></html>');
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		gsystem_pkg.printErrorPage('No student information found!');
END showGrades;
--------------------------------------------------------------------
--##################################################################
-- showStudentGrades gradeAllAssignments
--##################################################################
PROCEDURE showStudentGrades(unum IN VARCHAR2,crsTitle IN VARCHAR2,commMode IN VARCHAR2, stdName IN VARCHAR2)
IS
	std		XXstudentsXX%ROWTYPE;
BEGIN
	IF NOT selectStudentByName(crsTitle,stdName,std) THEN
		RETURN;
	END IF;
	showGrades(unum,crsTitle,std.ssn,NULL);
END showStudentGrades;
--------------------------------------------------------------------
--##################################################################
--addPerformanceRecord
--##################################################################
PROCEDURE addPerformanceRecord(stdID IN VARCHAR2,crsTitle IN VARCHAR2,grd IN VARCHAR2,avr IN VARCHAR2,publc IN VARCHAR2,ta IN VARCHAR2,secret IN VARCHAR2)
IS
BEGIN
			INSERT INTO XXperformanceXX
			VALUES (stdID,crsTitle,grd,avr,publc,ta,secret);
			IF SQL%NOTFOUND THEN
				gsystem_pkg.printErrorPage('System failed to add  performance record! ');
			END IF;
			COMMIT;
	EXCEPTION
		WHEN DUP_VAL_ON_INDEX THEN
			gsystem_pkg.printErrorPage('Logic error,#123, please report!');
END addPerformanceRecord;
--------------------------------------------------------------------
--##################################################################
--addGrading(crsTitle,stdID,id,gr,ex,com,tacom,NULL);
--##################################################################
PROCEDURE addGrading(crsTitle IN VARCHAR2,stdID IN VARCHAR2,id IN NUMBER,gr IN VARCHAR2,ex IN VARCHAR2,part IN VARCHAR2,com IN VARCHAR2,tacom IN VARCHAR2,scrt IN VARCHAR2)
IS
BEGIN
	IF gr IS NULL THEN
		RETURN;
	END IF;
	INSERT INTO XXgradesXX
	VALUES (stdID,crsTitle,id,gr,ex,part,com,tacom,scrt);
	IF SQL%NOTFOUND THEN
		gsystem_pkg.printErrorPage('System failed to add!');	
	END IF;
	COMMIT;
	EXCEPTION
		WHEN DUP_VAL_ON_INDEX THEN
			gsystem_pkg.printErrorPage('Logic error,#120, please report!');
END addGrading;
--------------------------------------------------------------------
--##################################################################
-- updateGrading(course,stdID,jsraw);
--##################################################################
PROCEDURE updateGrading(crsTitle IN VARCHAR2,stdID IN VARCHAR2,aid IN NUMBER,gr IN VARCHAR2,ex IN VARCHAR2,grb IN VARCHAR2,wg IN NUMBER,pt IN VARCHAR2,com IN VARCHAR2,tacom IN VARCHAR2)
IS
BEGIN 
		UPDATE XXgradesXX g
			SET  	g.grade=gr,	g.egrade=ex,g.partials=pt,g.comm=com, g.tacomm=tacom
			WHERE g.course=crsTitle AND g.ssn=stdID AND g.assid=aid;
		COMMIT;
		IF SQL%NOTFOUND THEN
			addGrading(crsTitle,stdID,aid,gr,ex,pt,com,tacom,NULL);
		END IF;
		UPDATE XXassignmentsXX a 
			SET a.gBase=grb, a.weight=wg WHERE  a.course=crsTitle AND  a.assid=aid;
		COMMIT;
		IF SQL%NOTFOUND THEN
			gsystem_pkg.printErrorPage('System failed to update the grading base! ');
		END IF;
END updateGrading;
--------------------------------------------------------------------
--##################################################################
-- updateGrading(course,stdID,jsraw);
--##################################################################
PROCEDURE parseUpdateGrading(crsTitle IN VARCHAR2,stdID IN VARCHAR2,jsrawData IN VARCHAR2)
IS
	ind 		NUMBER(4);
	last 		NUMBER(4);
	id number(3); gr VARCHAR2(20);grb VARCHAR2(20); ex VARCHAR2(20); com VARCHAR2(2000); tacom VARCHAR2(2000); wg VARCHAR2(3); pt VARCHAR2(30);
	av VARCHAR2(20); fg VARCHAR2(2); rm VARCHAR2(2000);trm VARCHAR2(2000);srm VARCHAR2(2000);
	jsraw		VARCHAR2(30000);
	secret boolean default false;
BEGIN
	jsraw:=jsrawData;
	last:=instr(jsraw,'{[~]}');
	while last > 0
	loop
		ind:=instr(jsraw,'{~}');
		id:=TO_NUMBER(substr(jsraw,0,ind-1));
		jsraw:=substr(jsraw,ind+3);
		ind:=instr(jsraw,'{~}');
		gr:=substr(jsraw,0,ind-1);
		jsraw:=substr(jsraw,ind+3);
		ind:=instr(jsraw,'{~}');
		grb:=substr(jsraw,0,ind-1);
		jsraw:=substr(jsraw,ind+3);
		ind:=instr(jsraw,'{~}');         ---
		ex:=substr(jsraw,0,ind-1);     ---
		jsraw:=substr(jsraw,ind+3);  ---
		ind:=instr(jsraw,'{~}');         ---
		wg:=substr(jsraw,0,ind-1);     ---
		jsraw:=substr(jsraw,ind+3);  ---
		ind:=instr(jsraw,'{~}');         ---
		pt:=substr(jsraw,0,ind-1);     ---
		jsraw:=substr(jsraw,ind+3);  ---
		ind:=instr(jsraw,'{~}');
		com:=substr(jsraw,0,ind-1);
		jsraw:=substr(jsraw,ind+3);
		ind:=instr(jsraw,'{[~]}');
		tacom:=substr(jsraw,0,ind-1);
		jsraw:=substr(jsraw,ind+5);
		--
		last:=instr(jsraw,'{[~]}');
		updateGrading(crsTitle,stdID,id,gr,ex,grb,wg,pt,com,tacom);
	end loop;
	--
	ind:=instr(jsraw,'{[a]}');
	av:=substr(jsraw,0,ind-1);
	jsraw:=substr(jsraw,ind+5);
	--
	ind:=instr(jsraw,'{[fg]}');
	fg:=substr(jsraw,0,ind-1);
	jsraw:=substr(jsraw,ind+6);
	--
	ind:=instr(jsraw,'{[rm]}');
	rm:=substr(jsraw,0,ind-1);
	jsraw:=substr(jsraw,ind+6);
	--
	ind:=instr(jsraw,'{[trm]}');
	trm:=substr(jsraw,0,ind-1);
	jsraw:=substr(jsraw,ind+7);
	--
	ind:=instr(jsraw,'{[srm]}');
	if ind >0 THEN
		srm:=substr(jsraw,0,ind-1);
		jsraw:=substr(jsraw,ind+5);
		secret:=true;
	end IF;
	-- ******************* select ssn,course,assid from xxgradesxx;
	av:=calculateAverage(crsTitle,stdID,false); -- false means calculate all assignments
	IF secret THEN
		UPDATE XXperformanceXX s
		SET  	s.grade=fg,s.average=av,s.public_remark=rm,s.ta_remark=trm,s.secret_remark=srm
			WHERE s.course=crsTitle AND s.ssn=stdID ;
	ELSE
		UPDATE XXperformanceXX s
		SET  	s.grade=fg,s.average=av,s.public_remark=rm,s.ta_remark=trm
			WHERE s.course=crsTitle AND s.ssn=stdID ;
	END IF;
	COMMIT;
	IF SQL%NOTFOUND THEN
		addPerformanceRecord(stdID,crsTitle,fg,av,rm,trm,srm);
	END IF;
END parseUpdateGrading;
------------------------------------------------------------------	  **
---##################################################################	******
-- commandServer							  **
--##################################################################	 *  *	
PROCEDURE commandServer(unum IN VARCHAR2,crsTitle IN VARCHAR2,request IN VARCHAR2, stdID IN VARCHAR2,jsraw IN VARCHAR2)
IS  
BEGIN
	IF request='SHOW_STD' THEN
		showGrades(unum,crsTitle,stdID,'puttimeout');
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'grading:CS:'||request) THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF request='UPDATE' THEN
		parseUpdateGrading(crsTitle,stdID,jsraw);
		showGrades(unum,crsTitle,stdID,'DO NOT PUT TIME-OUT');
	ELSIF request='SHOW' THEN
		showGrades(unum,crsTitle,stdID,'DO NOT PUT TIME-OUT');
	END IF;
END commandServer;
------------------------------------------------------------------	  **
---##################################################################	******
-- commandServer							  **
--##################################################################	 *  *	
PROCEDURE commandServer(unum IN VARCHAR2,crsTitle IN VARCHAR2,request IN VARCHAR2, stdID IN VARCHAR2,
ai in NUMBER,g in VARCHAR2,e in VARCHAR2,gb in VARCHAR2,w in NUMBER,p in VARCHAR2,c in VARCHAR2,tc in VARCHAR2)
IS  
	av VARCHAR2(20);
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'grading:CS:'||request) THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF request='UPDATE' THEN
		updateGrading(crsTitle,stdID,ai,g,e,gb,w,p,c,tc);
		av:=calculateAverage(crsTitle,stdID,false);
		UPDATE XXperformanceXX s 	SET  s.average=av WHERE s.course=crsTitle AND s.ssn=stdID ;
		COMMIT;
		IF SQL%NOTFOUND THEN
			addPerformanceRecord(stdID,crsTitle,null,av,null,null,null);
		END IF;
		showGrades(unum,crsTitle,stdID,'DO NOT PUT TIME-OUT');
	END IF;
END commandServer;
---------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--------------------------------------------------------------------
--##################################################################
-- OrderStudents like Statistics
--##################################################################
PROCEDURE OrderStudents(unum IN VARCHAR2,crsTitle IN VARCHAR2)
IS
	grade_cur 	GenericCurType;
	grd		XXgrade_customizeXX%ROWTYPE;
	astudent	XXstudentsXX%ROWTYPE;
	student_cur 	GenericCurType;
	stdavg		VARCHAR2(20);
	gradeType 	VARCHAR2(100);
	counter 	Number(2) DEFAULT 0;
	currentssn	VARCHAR2(20);
	last		VARCHAR2(20);
	color		VARCHAR2(8):='yellow';
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'grading:statistics') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	htp.p('<HTML><HEAD><BODY BGCOLOR=white>');
	htp.p('<h2> '||crsTitle||' Student Ranking </h2>');
	SELECT assType INTO gradeType FROM XXcoursesXX c WHERE c.courseTitle=crsTitle;
	IF gradeType='customized' THEN
		last:='tyrtrerf';
		htp.bp('<h3><font color=red> This course grading is customized; students are grouped but the groups are not listed in order with others.</font></h3>');
		htp.bp('<TABLE BORDER=0>');
		IF NOT student_cur%ISOPEN THEN      -- open the cursor if
			OPEN student_cur FOR 
    				SELECT average,ssn FROM XXperformanceXX  s
    				WHERE   crsTitle=s.course AND NOT average='NAP'
    		                ORDER BY average DESC;
	        END IF;
 			-- Fetch rows into PL/SQL table
		LOOP
			FETCH student_cur INTO stdavg,currentssn;
                	EXIT WHEN student_cur%NOTFOUND;
			SELECT * INTO astudent FROM XXstudentsXX s WHERE s.ssn=currentssn and crsTitle=s.course  ;
			IF NOT last=stdavg THEN
				IF color ='yellow' THEN color :='pink'; ELSE color :='yellow'; END IF;
			END IF;
			last:=stdavg;
			htp.bp('<tr><td bgcolor="'||color ||'"><b>'||stdavg||'</td><td><a href="'||gsystem_pkg.cgi||'ggrading_pkg.gradeAllAssignments?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode=SHOW&'||'stdID='||astudent.ssn ||'" target=temp ><b>'||astudent.firstname||' '||astudent.midname||' '||astudent.lastname||' </td></tr>');
	        END LOOP;
        	CLOSE student_cur;
		htp.bp('</table>');

	ELSE 
		htp.bp('<TABLE BORDER=0>');
		IF NOT student_cur%ISOPEN THEN      -- open the cursor if
			OPEN student_cur FOR 
    				SELECT average,ssn FROM XXperformanceXX  s
    				WHERE   crsTitle=s.course AND NOT average='NAP'
    		                ORDER BY TO_NUMBER(average) DESC;
	        END IF;
 			-- Fetch rows into PL/SQL table
		LOOP
			FETCH student_cur INTO stdavg,currentssn;
                	EXIT WHEN student_cur%NOTFOUND;
			SELECT * INTO astudent FROM XXstudentsXX s WHERE s.ssn=currentssn and crsTitle=s.course  ;
			htp.bp('<tr><td><b>'||stdavg||'</td><td><a href="'||gsystem_pkg.cgi||'ggrading_pkg.gradeAllAssignments?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode=SHOW&'||'stdID='||astudent.ssn ||'" target=temp ><b>'||astudent.firstname||' '||astudent.midname||' '||astudent.lastname||' </td></tr>');
--			IF NOT stdavg IS NULL THEN
--			--htp.bp('
--<IMG SRC="'||gsystem_pkg.host||'images/blueblock.gif" height='||TO_CHAR(2*TO_NUMBER(stdavg)) ||' WIDTH=3 BORDER=1>
	--		');	
	--		END IF;	
	        END LOOP;
        	CLOSE student_cur;
		htp.bp('</table>');
	--	htp.bp('</td></tr>
--<tr><td height=1 ></td><td height=1  ></td><td bgcolor=red height=1 width=500><IMG SRC="'||gsystem_pkg.host||'images/line.gif"></td></tr>
--<tr><td>0</td><td></td><td><center><i>Students</td></tr>
--</TABLE>
	--	');
	END IF;
	htp.p('</body></html>');
END OrderStudents;
--------------------------------------------------------------------
--##################################################################
-- Statistics
--##################################################################
PROCEDURE Statistics(unum IN VARCHAR2,crsTitle IN VARCHAR2)
IS
	grade_cur 	GenericCurType;
	grd		XXgrade_customizeXX%ROWTYPE;
	student_cur 	GenericCurType;
	stdavg		VARCHAR2(20);
	gradeType 	VARCHAR2(100);
	counter 	Number(2) DEFAULT 0;
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'grading:statistics') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	htp.p('<HTML><HEAD><BODY BGCOLOR=white>');
	htp.p('<h2> '||crsTitle||' Average Statistics</h2>');
	SELECT assType INTO gradeType FROM XXcoursesXX c WHERE c.courseTitle=crsTitle;
	IF gradeType='customized' THEN
		htp.p('<hr><TABLE BORDER=0>');
		IF NOT grade_cur%ISOPEN THEN      -- open the cursor if
	      		gsystem_pkg.open_cv (grade_cur,'XXgrade_customizeXX',crsTitle);  
	      	END IF;
	 		-- Fetch rows into PL/SQL table
		LOOP
			FETCH grade_cur INTO grd;
      			EXIT WHEN grade_cur%NOTFOUND;
			SELECT COUNT INTO counter 
				FROM XXperformanceXX s
				WHERE crsTitle=s.course AND s.average=grd.grade;
			htp.bp('<tr>
<td BGCOLOR=blue><font FACE="Arial,Helvetica" COLOR=white > <b>'|| UPPER(grd.grade)||'</td>
<TD ALIGN=LEFT width=270 bgcolor=cyan>
			');
			IF NOT counter=0 THEN
			htp.bp('
<IMG SRC="'||gsystem_pkg.host||'images/blueblock.gif" HEIGHT=15 WIDTH='||TO_CHAR(counter*2)||' BORDER=1>
			');
			END IF;
			htp.p('</TD></tr>');		
	        END LOOP;
        	CLOSE grade_cur;
		htp.p('</TABLE><hr>');
	ELSE 
		htp.bp('<TABLE BORDER=0><tr><td valign=top>100</td><td height=200 width=1 bgcolor=red>
<IMG SRC="'||gsystem_pkg.host||'images/line.gif"></td><td bgcolor=white ALIGN=LEFT VALIGN="bottom">');
		IF NOT student_cur%ISOPEN THEN      -- open the cursor if
			OPEN student_cur FOR 
    				SELECT average FROM XXperformanceXX  s
    				WHERE   crsTitle=s.course AND NOT average='NAP'
    		                ORDER BY TO_NUMBER(average) ASC;
	        END IF;
 			-- Fetch rows into PL/SQL table
		LOOP
			FETCH student_cur INTO stdavg;
                	EXIT WHEN student_cur%NOTFOUND;
			IF NOT stdavg IS NULL THEN
			htp.bp('
<a href="" onMouseOver=parent.info.document.current.set.value="'||stdavg||'"> 
<IMG SRC="'||gsystem_pkg.host||'images/blueblock.gif" height='||TO_CHAR(2*TO_NUMBER(stdavg)) ||' WIDTH=3 BORDER=1>
</a>
			');	
			END IF;	
	        END LOOP;
        	CLOSE student_cur;
		htp.bp('</td></tr>
<tr><td height=1 ></td><td height=1  ></td><td bgcolor=red height=1 width=500><IMG SRC="'||gsystem_pkg.host||'images/line.gif"></td></tr>
<tr><td>0</td><td></td><td><center><i>Students</td></tr>
</TABLE>

	<form name=current>
	<input type=text  name=set value="Please point mouse to bars">
	</form>
	');
	END IF;
	htp.p('</body></html>');
END Statistics;
--------------------------------------------------------------------
--##################################################################
-- Statistics
--##################################################################
PROCEDURE Statistics(unum IN VARCHAR2,crsTitle IN VARCHAR2,VassID IN NUMBER)
IS
	grade_cur 	GenericCurType;
	grd		XXgrade_customizeXX%ROWTYPE;
	agrades_cur 	GenericCurType;
	stdgrd		VARCHAR2(20);
	gradeType 	VARCHAR2(100);
	atyp		VARCHAR2(15);
	counter 	Number(2) DEFAULT 0;
	mult		Number(2);
	base 		VARCHAR2(40);
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'grading:statistics') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF VassID IS NULL THEN
		Statistics(unum,crsTitle);  --average
		return;
	END IF;
	SELECT typ,gBase INTO atyp,base FROM xxassignmentsXX a where  a.course=crsTitle AND VassID=a.assID;
	htp.p('<HTML><HEAD><BODY BGCOLOR=white>');
	htp.p('<h2> '||atyp||' ' ||Vassid||'  Statistics</h2>');
	SELECT assType INTO gradeType FROM XXcoursesXX c WHERE c.courseTitle=crsTitle;
	IF gradeType='customized' THEN
		htp.p('<hr><TABLE BORDER=0>');
		IF NOT grade_cur%ISOPEN THEN      -- open the cursor if
	      		gsystem_pkg.open_cv (grade_cur,'XXgrade_customizeXX',crsTitle);  
	      	END IF;
	 		-- Fetch rows into PL/SQL table
		LOOP
			FETCH grade_cur INTO grd;
      			EXIT WHEN grade_cur%NOTFOUND;
			SELECT COUNT INTO counter 
				FROM XXgradesXX g
				WHERE crsTitle=g.course AND g.grade=grd.grade AND g.assid=VassID;
			htp.bp('<tr>
<td BGCOLOR=blue ><font FACE="Arial,Helvetica" COLOR=yellow > <b>'|| UPPER(grd.grade)||'</td>
<TD ALIGN=LEFT width=270 bgcolor=cyan>
			');
			IF NOT counter=0 THEN
			htp.bp('
<IMG SRC="'||gsystem_pkg.host||'images/blueblock.gif" HEIGHT=15 WIDTH='||TO_CHAR(counter*2)||' BORDER=1>
			');
			END IF;
			htp.p('</TD></tr>');		
	        END LOOP;
        	CLOSE grade_cur;
		htp.p('</TABLE><hr>');
	ELSE 
		mult:=200/TO_NUMBER(base);
		htp.bp('<TABLE BORDER=0><tr><td valign=top>'||base||'</td><td height=200 width=1 bgcolor=red>
<IMG SRC="'||gsystem_pkg.host||'images/line.gif"></td><td bgcolor=white ALIGN=LEFT VALIGN="bottom">');
		IF NOT agrades_cur%ISOPEN THEN      -- open the cursor if
			OPEN agrades_cur FOR 
    				SELECT grade FROM XXgradesXX g
    				WHERE   crsTitle=g.course AND g.assID=VassID
    		                ORDER BY TO_NUMBER(grade) ASC;
	        END IF;
 			-- Fetch rows into PL/SQL table
		LOOP
			FETCH agrades_cur INTO stdgrd;
                	EXIT WHEN agrades_cur%NOTFOUND;
			IF NOT stdgrd IS NULL THEN
			htp.bp('
<a href="" onMouseOver=parent.info.document.current.set.value="'||stdgrd||'"> 
<IMG SRC="'||gsystem_pkg.host||'images/blueblock.gif" height='||TO_CHAR(mult*TO_NUMBER(stdgrd)) ||' WIDTH=3 BORDER=1>
</a>			');	
			END IF;	
	        END LOOP;
        	CLOSE agrades_cur;
		htp.bp('</td></tr>
<tr><td height=1 ></td><td height=1  ></td><td bgcolor=red height=1 width=500><IMG SRC="'||gsystem_pkg.host||'images/line.gif"></td></tr>
<tr><td>0</td><td></td><td><center><i>Students</td></tr>
</TABLE>
	<form name=current>
	<input type=text  name=set value="Please point mouse to bars">
	</form>
		');
	END IF;
	htp.p('</body></html>');
END Statistics;
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--------------------------------------------------------------------
--##################################################################
-- Assignment
--##################################################################
PROCEDURE Assignment(unum IN VARCHAR2,crsTitle IN VARCHAR2,commMode IN VARCHAR2, VassID IN NUMBER)
IS
BEGIN
	IF commMode like '%STAT%' THEN
		Statistics(unum,crsTitle,VassID);
		RETURN;
	ELSIF commMode like '%GRADE%' THEN
		IF NOT vassID is NULL THEN
			gradeAssignment(unum,crsTitle,VassID);
		ELSE
			htp.bp('
<html><body bgcolor=white><h2> Please click on the number of the assignment to grade.</h2>
<h4>Note that full colored home images goes to assignment`s home page,</h4>
<h4>little stars go to the comment home page of the assignment,</h4>
<h5>and full colored home image before the course name goes to course home page.</h5>
</body></html>
			');
		END IF;		
	END IF;
END Assignment;
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
END ggrading_pkg;
/
show err