CREATE OR REPLACE PACKAGE gsystem_pkg AS
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	TYPE GenericCurType is REF CURSOR;

--	host	CONSTANT VARCHAR2(60) :='http://osprey7.npac.syr.edu:3768/users-docs/msen7/GRADING/';
	host	CONSTANT VARCHAR2(60) :='https://osprey7.npac.syr.edu:5557/';
	
--	cgi	CONSTANT VARCHAR2(60) :='http://osprey7.npac.syr.edu:3768/users-cgi/msen7/wow/';
--	cgi	CONSTANT VARCHAR2(60) :='http://osprey7.npac.syr.edu:9706/msen/owa/';
	cgi	CONSTANT VARCHAR2(60) :='https://osprey7.npac.syr.edu:5557/DB/gs/';
--	cgi	CONSTANT VARCHAR2(60) :='https://osprey7.npac.syr.edu:5557/DB/gs_test/';

--	images  CONSTANT VARCHAR2(70) :='http://osprey7.npac.syr.edu:3768/users-docs/msen7/GRADING/images/';
	images  CONSTANT VARCHAR2(70) :='https://osprey7.npac.syr.edu:5557/images/';

--
	SUPER  		CONSTANT NUMBER(1) :=0;
	INSTRUCTOR	CONSTANT NUMBER(1) :=1;
	CO_INSTRUCTOR	CONSTANT NUMBER(1) :=2;
	TA		CONSTANT NUMBER(1) :=3;
	SYSTEM		CONSTANT NUMBER(1) :=4;
	BROWSER		CONSTANT NUMBER(1) :=5;
	
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	PROCEDURE open_cv (		generic_cv IN OUT GenericCurType,
			  		tableName IN VARCHAR2,
					condition IN VARCHAR2);
	PROCEDURE printErrorPage( 	message IN VARCHAR2);
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	PROCEDURE getAccess(		loginID IN VARCHAR2, 
					password IN VARCHAR2, 
					x in Number, 
					y in number);

	FUNCTION getPrivateDataPermission(
					uname IN VARCHAR2, 
					crsTitle IN VARCHAR2, 
					PR IN NUMBER, 
					data IN VARCHAR2) 
		RETURN VARCHAR2;

	FUNCTION accessPermit(		unum IN VARCHAR2, 
					crsTitle IN VARCHAR2, 
					accessStr IN VARCHAR2) 
		RETURN BOOLEAN;
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	PROCEDURE courseSelectionPage(	unum IN VARCHAR2, 
					choice IN VARCHAR2);

	PROCEDURE courseSelect(		unum IN VARCHAR2, 
					choice IN VARCHAR2, 
					name IN VARCHAR2,
					term IN VARCHAR2, 
					year IN VARCHAR2);
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	PROCEDURE Back;

	PROCEDURE BackGuaranteed;

	PROCEDURE goBackPage;

	PROCEDURE insert_shut_off_scripts(
					mins IN NUMBER,
					secs IN NUMBER);
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
http://osprey7.npac.syr.edu:3768/users-cgi/msen7/wow/
'||gsystem_pkg.cgi||'
http://osprey7.npac.syr.edu:3768/users-docs/msen7/GRADING/images/
'||gsystem_pkg.images||'
http://osprey7.npac.syr.edu:3768/users-docs/msen7/GRADING/
'||gsystem_pkg.host||'
*/
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
END gsystem_pkg;
/   
show err
