CREATE OR REPLACE PACKAGE BODY guser_pkg AS
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/                        _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/  User Record PROCEDURES  /_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_                       _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--------------------------------------------------------------------
--##################################################################
-- userManipulationPage
--##################################################################
PROCEDURE userManipulationPage(	unum IN vARCHAR2)
IS
BEGIN 
	htp.bp('
<html>
<title>User Records Manipulation Page</title>
<frameset cols="200,*" border=0>
<frame src="'||gsystem_pkg.cgi||'guser_pkg.listUsers?unum='||unum||'" name=menu scrolling=yes frameborder=0 marginwidth=2 marginheight=2>
<frame src="'||gsystem_pkg.cgi||'guser_pkg.sys_user?unum='||unum||'&'||'commMode=&'||'usrID=" name=info scrolling=yes frameborder=0>
</frameset>
<noframe>
<body bgcolor=white>
<h2>Error: You need frames for this!</h2></body></noframe>
<font size=-1><i>NPAC</i></font>
</body></html>
 ');
END userManipulationPage;
--------------------------------------------------------------------
--##################################################################
-- listUsers
--##################################################################
PROCEDURE listUsers(unum IN VARCHAR2)
IS
	user_cur 	GenericCurType;
	usr		XXUsersXX%ROWTYPE;
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,NULL,'user:listUsers') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	htp.p('
<html><body bgcolor=white>
<base target=info>
<table>
<tr>');
	htp.p('
<td><b>Users</b></td></tr>
<td colspan=2><hr></td></tr>
	');
	IF NOT user_cur%ISOPEN THEN      -- open the cursor if
	            gsystem_pkg.open_cv (user_cur,'XXUsersXX',NULL);    -- not open yet
        END IF;
 	-- Fetch rows into PL/SQL table
	LOOP
		FETCH user_cur INTO usr;
                EXIT WHEN user_cur%NOTFOUND;
		IF usr.homeURL IS NULL THEN
			htp.bp('
<tr><td>
<img src='||gsystem_pkg.images||'homeempty.jpg border=0 align=center> 
</td>	
			');
		ELSE
			htp.bp('
<tr><td>
<a href='||usr.homeURL||'><img src='||gsystem_pkg.images||'homefull.jpg border=0 align=center></a> 
</td>
			');
		END IF;
		htp.bp('
<td><a href="'||gsystem_pkg.cgi||'guser_pkg.sys_user?unum='||unum||'&'||'commMode=SHOW&'||'usrID='||usr.idnum||'" ><b>'||usr.username||'</b></a></td></tr>
			');
        END LOOP;
        CLOSE user_cur;
	htp.bp('
<td colspan=2><hr></td></tr>
</table></body></html><font size=-1><i>NPAC</i></font> </body></html>
	');
END listUsers;
--------------------------------------------------------------------
--##################################################################
-- findRestrictedList
--##################################################################
PROCEDURE findRestrictedList(acclst IN VARCHAR2, restlst IN OUT VARCHAR2)
IS
	course_cur 	GenericCurType;
	acourse		XXcoursesXX%ROWTYPE;
--	crsTitle	VARCHAR2(60);
BEGIN
	restlst:='';
	IF NOT course_cur%ISOPEN THEN      -- open the cursor if
	            gsystem_pkg.open_cv (course_cur,'XXcoursesXX',NULL);    -- not open yet
        END IF;
 	-- Fetch rows into PL/SQL table
	LOOP
		FETCH course_cur INTO acourse;
                EXIT WHEN course_cur%NOTFOUND;
		IF acclst like '%'||acourse.courseTitle||'%' THEN
			NULL;
		ELSE	restlst:=restlst||'<OPTION>'||acourse.courseTitle;
		END IF;
        END LOOP;
        CLOSE course_cur;
END findRestrictedList;
--------------------------------------------------------------------
--##################################################################
-- getHTMLformatShow(course,usrID);
--##################################################################
PROCEDURE getHTMLformatShow(usrID IN VARCHAR2,buttons IN VARCHAR2,scriptMode in VARCHAR2)
IS
	usr	XXUsersXX%ROWTYPE;
	script  VARCHAR2(50) DEFAULT 'top.menu.document.location.reload();';
	restrictedlst	VARCHAR2(2000);
BEGIN
	IF usrID=NULL THEN
		gsystem_pkg.printErrorPage('There is no user identification to show!');
		return ;
	END IF;
	SELECT	* INTO usr FROM XXusersXX u WHERE u.idnum=usrID;
	findRestrictedList(usr.acclst,restrictedlst);
	htp.bp('
<html>
<script language="JavaScript">
var editmode="false";
var access="'||usr.acclst||'";
var restricted="'||restrictedlst||'";
var privilige='||TO_CHAR(usr.privilige) ||';
parent.activator();
	');
	IF scriptMode='SHOWupdatelist' THEN
		htp.p(script);
	END IF;
	htp.bp('
</script>
<body bgcolor=white>  
<b>
<form action='||gsystem_pkg.cgi||'guser_pkg.commandServer
name="user" method="POST" target=info>
'||buttons ||'
<input type=hidden name=usrID  value="'||usr.idnum||'"> 
<input type=hidden name=privilige  value='||TO_CHAR(usr.privilige) ||'> 
<input type=hidden name=access  value="&{access};"> 
<input type=hidden name=username size=30 value="'||usr.username ||'">
<input type=hidden name=login size=30 value="'||usr.login ||'">
<input type=hidden name=pwd size=30 value="'||usr.pwd ||'">
<input type=hidden name=umail size=30 value="'||usr.umail ||'">
<input type=hidden name=homeURL size=30 value="'||usr.homeURL ||'">
<input type=hidden name=picURL size=30 value="'||usr.picURL ||'">
<input type=hidden name="comments"  rows=4 cols=30>'||usr.comments ||'
<table bgcolor=red><th>
<table bgcolor=yellow cellpadding=6 border=5 >
<tr><td width=300><b>User Name</b></td><td>'||usr.username ||'</td></tr>
<tr><td width=300><b>Login ID</b></td><td>'||usr.login ||'</td></tr>
<tr><td width=300><b>Password</b></td><td>'||usr.pwd ||'</td></tr>
<tr><td><b>E-mail</b></td><td>'||usr.umail ||'</td></tr>
<tr><td><b>Home Page URL </b></td><td>'||usr.homeURL ||'</td></tr>
<tr><td><b>Picture URL </b></td><td>'||usr.picURL ||'</td></tr>
<tr><td><b>Notes</b></td><td>'||usr.comments ||'</td></tr>
</table>
</th>
</table>
</form>
</b>
<hr>
</body></html>
	');
END getHTMLformatShow;
--------------------------------------------------------------------
--##################################################################
-- selectAssignment(course,assID,ass);	
--##################################################################
PROCEDURE selectUser(usrID IN VARCHAR2,usr OUT XXuserSXX%ROWTYPE)
IS
BEGIN
	IF NOT (usrID IS NULL) THEN
		SELECT	* INTO usr FROM XXusersXX u WHERE u.idnum=usrID;
	ELSE
		gsystem_pkg.printErrorPage('Null user id passed!.Please report to msen7@npac');
	END IF;
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		usr.idnum:=usrID;
		usr.privilige:=5;
END ;
--------------------------------------------------------------------
--##################################################################
-- getHTMLformatEdit(course,usrID);
--##################################################################
PROCEDURE getHTMLformatEdit(usrID IN VARCHAR2,buttons IN VARCHAR2) 
IS
	usr		XXUsersXX%ROWTYPE;
	restrictedlst	VARCHAR2(2000);
BEGIN
	selectUser(usrID,usr);
	findRestrictedList(usr.acclst,restrictedlst);
	htp.bp('
<html>
<script language="JavaScript">
var editmode="true";
var access="'||usr.acclst||'";
var restricted="'||restrictedlst||'";
var privilige='||TO_CHAR(usr.privilige) ||';
parent.activator();
//top.al.document.location="'||gsystem_pkg.host||'alPage.html";
//top.rl.document.location="'||gsystem_pkg.host||'rlPage.html";
//top.js.document.location="'||gsystem_pkg.host||'jsPage.html";
//top.al.document.location="'||gsystem_pkg.cgi||'guser_pkg.alPage";
//top.rl.document.location="'||gsystem_pkg.cgi||'guser_pkg.rlPage";
</script>
<body bgcolor=white>  
<b>
<form action='||gsystem_pkg.cgi||'guser_pkg.commandServer
name="user" method="POST" target=info>
'||buttons ||'
<input type=hidden name=usrID  value="'||usrID||'"> 
<input type=hidden name=privilige  value='||TO_CHAR(usr.privilige) ||'> 
<input type=hidden name=access  value="&{access};"> 
<table bgcolor=red><th>
<table bgcolor=yellow cellpadding=6 >
<tr><td width=300><b>User Name</b></td><td><input name=username size=30 value="'||usr.username ||'"></td></tr>
<tr><td width=300><b>Login ID</b></td><td><input name=login size=30 value="'||usr.login ||'"></td></tr>
<tr><td width=300><b>Password</b></td><td><input name=pwd size=30 value="'||usr.pwd ||'"></td></tr>
<tr><td><b>E-mail</b></td><td><input name=umail size=30 value="'||usr.umail ||'"></td></tr>
<tr><td><b>Home Page URL </b></td><td><input name=homeURL size=30 value="'||usr.homeURL ||'"><br></td></tr>
<tr><td><b>Picture URL </b></td><td><input name=picURL size=30 value="'||usr.picURL ||'"><br></td></tr>
<tr><td><b>Notes</b></td><td><textarea type=hidden name="comments"  rows=4 cols=30>'||usr.comments ||'</textarea></td></tr>
</table>
</th>
</table>
</form>
</b>
<hr>
</body></html>
	');
END getHTMLformatEdit;
--------------------------------------------------------------------
--##################################################################
-- userFrames(
--##################################################################
PROCEDURE userFrames(unum IN VARCHAR2,commMode IN VARCHAR2, usrID IN  VARCHAR2)
IS
BEGIN
	htp.bp('
<html>
<script language="JavaScript">
var registered=0;
function activator(){
	registered+=1;
	if (registered==4) {
this.al.document.location="'||gsystem_pkg.host||'alPage.html";
this.rl.document.location="'||gsystem_pkg.host||'rlPage.html";
this.js.document.location="'||gsystem_pkg.host||'jsPage.html";
	}
}
</script>
<frameset rows="55%,*" border=0>
<frame src="'||gsystem_pkg.cgi||'guser_pkg.userFormHtml?unum='||unum||'&'||'commMode='||commMode||'&'||'usrID='||usrID||'"
 name=main scrolling=yes frameborder=0 marginwidth=2 marginheight=2>
<frameset cols="35%,30%,*" border=0>
<frame src="'||gsystem_pkg.cgi||'guser_pkg.emptyHtml" name=al scrolling=yes frameborder=0>
<frame src="'||gsystem_pkg.cgi||'guser_pkg.emptyHtml" name=js scrolling=yes frameborder=0>
<frame src="'||gsystem_pkg.cgi||'guser_pkg.emptyHtml" name=rl scrolling=yes frameborder=0>
</frameset>
</frameset>
<noframe>
<body bgcolor=white>
<h2>Error: You need frames for this!</h2></body></noframe>
<font size=-1><i>NPAC</i></font>
</body></html>
	 ');
END userFrames;
--------------------------------------------------------------------
--##################################################################
-- user(
--##################################################################
PROCEDURE use
IS
BEGIN htp.p('<html><body bgcolor=white>sdfg</body></htmL>'); return;
END use;
--------------------------------------------------------------------
--##################################################################
-- user(
--##################################################################
PROCEDURE sys_user(unum IN VARCHAR2,commMode IN VARCHAR2, usrID IN  VARCHAR2)
IS
BEGIN 
	IF commMode IS NULL THEN
		htp.bp('
<html><body bgcolor=white>
<b>
<form action='||gsystem_pkg.cgi||'guser_pkg.commandServer
method="POST" target=info>
	<input type=hidden name=unum  value="'||unum||'"> 
	<b><font color=black size=+1 FACE="Arial,Helvetica" >
	<input type=submit name=request value="NEW"></b></font>
	<input type=hidden name=usrID value="">
	<input type=hidden name="privilige" value= >
	<input type=hidden name="access" value="">
	<input type=hidden name="username" value="">
	<input type=hidden name="login" value="">
	<input type=hidden name="pwd" value="">
	<input type=hidden name="umail" value="">
	<input type=hidden name="homeURL" value="">
	<input type=hidden name="picURL" value="">
	<input type=hidden name="comments" value="">
<br><h2>Please click on the name of the user which you want to manipulate!</h2>
</body></htmL>
		');
	ELSE userFrames(unum ,commMode , usrID );
	END IF;
END sys_user;
--------------------------------------------------------------------
--##################################################################
-- userFormHtml
--##################################################################
PROCEDURE userFormHtml(unum IN VARCHAR2,commMode IN VARCHAR2, usrID IN  VARCHAR2)
IS
	buttons VARCHAR2(1000);
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,NULL,'user:userFormHtml') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF commMode='ADD' THEN   --  new user
		buttons:='	<font color=red><input type=submit name=request value="ADD" ></font>
				<input type=reset name=request value="UNDO" >
				<input type=submit name=request value="SKIP" >';
	ELSIF commMode='EDIT' THEN 
		buttons:='	<font color=red><input type=submit name=request value="UPDATE" ></font>
				<input type=reset name=request value="UNDO" >
				<input type=submit name=request value="SKIP" >
				<input type=submit name=request value="CANCEL" >';
	ELSE    
		buttons:='	<input type=submit name=request value="NEW" >
				<font color=red><input type=submit name=request value="DELETE" ></font>
				<input type=submit name=request value="EDIT" >
				<input type=submit name=request value="SKIP" >';
	END IF;
--      * ********************
	buttons:='<input type=hidden name=unum  value="'||unum ||'">
		<b><font color=black size=+1 FACE="Arial,Helvetica" >'
		||buttons ||'</b></font>';
	IF commMode like '%SHOW%' THEN
		getHTMLformatShow(usrID,buttons,commMode);
	ELSIF  commMode='ADD' OR commMode='EDIT'  THEN
		getHTMLformatEdit(usrID,buttons);
	END IF;
	--htp.bp('<hr><font size=-1><i>NPAC: you forgot something to uppercase</i></font> </body></html>');
END userFormHtml;
--------------------------------------------------------------------
--##################################################################
-- addUser(course,usrID,gBase,url,commUrl,notes);
--##################################################################
PROCEDURE addUser( VusrID IN VARCHAR2, Vprivilige IN NUMBER,Vaccess IN VARCHAR2,Vusername IN VARCHAR2,Vlogin IN VARCHAR2,Vpwd IN VARCHAR2,Vumail IN VARCHAR2,VhomeURL IN VARCHAR2,VpicURL IN VARCHAR2, Vcomments IN VARCHAR2 )
IS
	 ORA_01400 EXCEPTION;
BEGIN
	IF Vlogin IS NULL OR Vusername IS NULL THEN
		RAISE ORA_01400;
	END IF;
	INSERT INTO XXUsersXX
	VALUES (VusrID, Vprivilige,Vaccess ,INITCAP(Vusername),Vlogin,Vpwd ,Vumail,VhomeURL,VpicURL,Vcomments);
	IF SQL%NOTFOUND THEN
		gsystem_pkg.printErrorPage('System failed to add!');	
	END IF;
	COMMIT;
	EXCEPTION
		WHEN DUP_VAL_ON_INDEX THEN
			gsystem_pkg.printErrorPage('This user ,'||Vlogin||' already exists! You may update it, but duplication is not allowed!');
		WHEN ORA_01400 THEN
			gsystem_pkg.printErrorPage('The name and login id fields should not be empty!.');
END addUser;
--------------------------------------------------------------------
--##################################################################
-- updateUser(course,usrID,maxGrade,commentUrl,notes);
--##################################################################
PROCEDURE updateUser( VusrID IN VARCHAR2, Vprivilige IN NUMBER,Vaccess IN VARCHAR2,Vusername IN VARCHAR2,Vlogin IN VARCHAR2,Vpwd IN VARCHAR2,Vumail IN VARCHAR2,VhomeURL IN VARCHAR2,VpicURL IN VARCHAR2, Vcomments IN VARCHAR2 )
IS
BEGIN
	UPDATE XXUsersXX u
	SET  	idnum  		=VusrID,
		privilige  	=Vprivilige ,
		acclst  	=Vaccess,
		username 	=Vusername,
		login 		=Vlogin,
		pwd 		=Vpwd,
		umail 		=Vumail,
		homeURL 	=VhomeURL,
		picURL 		=VpicURL,
		comments 	=Vcomments
	WHERE u.idnum=VusrID;
	COMMIT;
	IF SQL%NOTFOUND THEN
		--gsystem_pkg.printErrorPage('System failed to update! Trying as a new user!');		
		addUser(VusrID, Vprivilige,Vaccess ,Vusername ,Vlogin ,Vpwd ,Vumail ,VhomeURL ,VpicURL , Vcomments);
	END IF;
END updateUser  ;
--------------------------------------------------------------------
--##################################################################
-- deleteUser(course,usrID);
--##################################################################
PROCEDURE deleteUser(VusrID IN VARCHAR2)
IS
BEGIN
	DELETE FROM XXUsersXX u
	WHERE VusrID=u.idnum;
	COMMIT;
	IF SQL%NOTFOUND THEN
		gsystem_pkg.printErrorPage('System failed to delete!<br> Record may be deleted already!');
	END IF;
END deleteUser;
--------------------------------------------------------------------
--##################################################################
-- commandServer
--##################################################################
PROCEDURE commandServer(unum IN VARCHAR2,request IN VARCHAR2, usrID IN VARCHAR2, privilige IN NUMBER,access IN VARCHAR2,username IN VARCHAR2,login IN VARCHAR2,pwd IN VARCHAR2,umail IN VARCHAR2,homeURL IN VARCHAR2,picURL IN VARCHAR2, comments IN VARCHAR2 )
IS
	last NUMBER(30);
BEGIN
	IF request='ADD' THEN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,NULL,'user:CS:ADD') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
		addUser(usrID, privilige,access ,username ,login ,pwd ,umail ,homeURL ,picURL , comments);
		sys_user(unum,'SHOWupdatelist',usrID);
	ELSIF request='NEW' THEN
		SELECT MAX(idnum) INTO last FROM XXusersXX;
		IF last IS NULL THEN
			last:=TO_CHAR(3294);
		ELSE last:=TO_CHAR(TO_NUMBER(last)+3);
		END IF;
		sys_user(unum,'ADD',last);
	ELSIF request='DELETE' THEN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,NULL,'user:CS:DELETE') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
		deleteUser(usrID);
		htp.p('<html> <script language=JavaScript> top.document.location.reload();</script></html>');
	ELSIF request='UPDATE' THEN 
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,NULL,'user:CS:UPDATE') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
		updateUser(usrID, privilige,access ,username ,login ,pwd ,umail ,homeURL ,picURL , comments);
		sys_user(unum,'SHOWupdatelist',usrID);
	ELSIF request='EDIT' THEN 
		sys_user(unum,'EDIT',usrID);
	ELSIF request='CANCEL' THEN htp.p('');
		htp.p('<html> <script language=JavaScript> history.go(-2);</script></html>');
		--user(unum,NULL,NULL,NULL);
	ELSIF request='SKIP' THEN 
		sys_user(unum,NULL,NULL);
	END IF;
htp.p('');
END commandServer;
/*
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
*/
--------------------------------------------------------------------
--##################################################################
-- emptyHtml
--##################################################################
PROCEDURE emptyHtml
IS
BEGIN
	htp.bp('
<html>
<script language="JavaScript">
now= new Date();
document.write("<h2>Today`s date and time ");
document.write(now.toLocaleString());
document.write("<br>Please wait</h2>");
parent.activator();
</script>
<body></body>
</html>	');
END emptyHtml;
/*followings are implemented outside the database
------------------------------------------------------------------
--##################################################################
-- pageJShtml
--##################################################################
PROCEDURE pageJShtml(commMode IN VARCHAR2)
IS
BEGIN
END pageJShtml;
--##################################################################
-- alPage
--##################################################################
PROCEDURE alPage
IS
BEGIN
END alPage;
--##################################################################
-- rlPage
--##################################################################
PROCEDURE rlPage
IS
BEGIN
END rlPage;
*/
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
END guser_pkg;
/
show err