CREATE OR REPLACE PACKAGE gassignment_pkg AS
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	TYPE GenericCurType is REF CURSOR;
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	PROCEDURE assignmentManipulationPage(	unum IN vARCHAR2,           --*- no security -*--
						crsTitle IN VARCHAR2,
						url_left IN VARCHAR2 ,
						url_right IN VARCHAR2 );

	PROCEDURE listAssignments(	unum IN VARCHAR2,              --*- no security -*--
					crsTitle IN VARCHAR2);

	PROCEDURE publishAssignment(		unum IN VARCHAR2,		--*- no security -*--
						crsTitle IN VARCHAR2,
						VassID IN VARCHAR2,
						pub IN VARCHAR2
						);

	PROCEDURE assignment(		unum IN VARCHAR2, 		 --*- no security -*--
					crsTitle IN VARCHAR2,
					commMode IN VARCHAR2,
					assID IN NUMBER,
					script IN VARCHAR2);

	PROCEDURE commandServer(	unum IN VARCHAR2,
					crsTitle IN VARCHAR2,
					request IN VARCHAR2,
					assID IN NUMBER, T IN  VARCHAR2,
					gBase IN VARCHAR2,
					weight IN NUMBER,
					publish  IN VARCHAR2,
					url IN VARCHAR2,
					commUrl IN VARCHAR2,
					notes IN VARCHAR2,
					partials IN VARCHAR2
				);
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
END gassignment_pkg;
/   
show err
