CREATE OR REPLACE PACKAGE ggrading_pkg AS
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	TYPE GenericCurType is REF CURSOR;
--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	PROCEDURE gradingMenuPage(		unum IN vARCHAR2,		--*- no security -*--
						crsTitle IN VARCHAR2);

	PROCEDURE gradingManipulationPage(	unum IN vARCHAR2,		--*- no security -*--
						crsTitle IN VARCHAR2,
						choice IN VARCHAR2);

	PROCEDURE listStudents(			unum IN VARCHAR2,		--*- no security -*--
						crsTitle IN VARCHAR2);

	PROCEDURE listAssignments(		unum IN VARCHAR2,		--*- no security -*--
						crsTitle IN VARCHAR2,
						commMode IN VARCHAR2);

	PROCEDURE publishAssignment(		unum IN VARCHAR2,		--*- no security -*--
						crsTitle IN VARCHAR2,
						commMode IN VARCHAR2,
						VassID IN VARCHAR2,
						pub IN VARCHAR2
						);

	PROCEDURE Assignment(			unum IN VARCHAR2,		--*- intristic security -*--
						crsTitle IN VARCHAR2,
						commMode IN VARCHAR2,
						VassID IN NUMBER);

	PROCEDURE gradeAllAssignments(		unum IN VARCHAR2,		
						crsTitle IN VARCHAR2,
						commMode IN VARCHAR2,
						stdID IN VARCHAR2);

PROCEDURE showStudentGrades(unum IN VARCHAR2,crsTitle IN VARCHAR2,commMode IN VARCHAR2, stdName IN VARCHAR2);


	PROCEDURE commandServer(		unum IN VARCHAR2,
						crsTitle IN VARCHAR2,
						request IN VARCHAR2,
						stdID IN VARCHAR2,
						jsraw IN VARCHAR2);

	PROCEDURE commandServer(		unum IN VARCHAR2,
						crsTitle IN VARCHAR2,
						request IN VARCHAR2,
						stdID IN VARCHAR2,
						ai in NUMBER,
						g in VARCHAR2,
						e in VARCHAR2,
						gb in VARCHAR2,
						w in NUMBER,
						p in VARCHAR2,
						c in VARCHAR2,
						tc in VARCHAR2);

	PROCEDURE updateAverages(unum IN vARCHAR2,crsTitle IN VARCHAR2);

	PROCEDURE OrderStudents(		unum IN VARCHAR2,
						crsTitle IN VARCHAR2);
	PROCEDURE Statistics(			unum IN VARCHAR2,
						crsTitle IN VARCHAR2);

	PROCEDURE STDINFOPAGE;							--*- no security -*--
	PROCEDURE setOption(	
						select_option	IN VARCHAR2,
						unum IN VARCHAR2,		--*- no security -*--
						crsTitle IN VARCHAR2,
						prefer IN VARCHAR2);
	PROCEDURE gradingOptionsPage(		unum IN VARCHAR2,		--*- no security -*--
						crsTitle IN VARCHAR2);


--___________________________________________________________________________
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
END ggrading_pkg;
/ 
show err