CREATE OR REPLACE PACKAGE BODY std AS
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
TYPE	surveyQuestionType	IS RECORD (
	id	NUMBER(3),
	c0 NUMBER(2),c1  NUMBER(2),c2  NUMBER(2),c3  NUMBER(2),c4  NUMBER(2),b0  VARCHAR2(100),b1  VARCHAR2(100),b2  VARCHAR2(100),b3  VARCHAR2(100),b4  VARCHAR2(100)
	);
TYPE	SurveyTableType	IS TABLE OF surveyQuestionType INDEX BY  BINARY_INTEGER; --xxsurveyxx%TYPE
cs	SurveyTableType;
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/                        _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/  student site PROCEDURES     /_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_                       _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------
--##################################################################
-- postOffice
--##################################################################
PROCEDURE postOffice(course IN VARCHAR2)
IS
BEGIN 
	gutil_pkg.utilManipulationPage('evrubody',course,'Post Office' );
END postOffice;
--------------------------------------------------------------------
--##################################################################
-- class list
--##################################################################
PROCEDURE classList(course IN VARCHAR2)
IS
BEGIN 
	gutil_pkg.utilManipulationPage('evrubody',course,'E-mail List');
END classList;
--------------------------------------------------------------------------------
--------------------------------------------------------------------
--##################################################################
-- gradingMenuPage
--##################################################################
PROCEDURE student
IS
BEGIN 
	gsystem_pkg.courseSelectionPage('a_student','STUDENT ACCESS');
END student;
--------------------------------------------------------------------
--##################################################################
-- 
--##################################################################
PROCEDURE register
IS
BEGIN 
	gsystem_pkg.courseSelectionPage('a_student','STUDENT REGISTER');
END register;
--------------------------------------------------------------------
--##################################################################
-- gradingMenuPage
--##################################################################
PROCEDURE student(unum IN VARCHAR2)
IS
BEGIN 
	gsystem_pkg.courseSelectionPage(unum,'STUDENT ACCESS');
END student;
--------------------------------------------------------------------
--##################################################################
-- 
--##################################################################
PROCEDURE changePassword(crsTitle IN VARCHAR2,lgn IN vARCHAR2, pwd IN vARCHAR2)
IS
BEGIN 
	UPDATE XXstudentsXX s
	SET  	
	s.gspwd=pwd
	WHERE s.course=crsTitle AND s.ssn=lgn;
	COMMIT;
	IF SQL%NOTFOUND THEN
		gsystem_pkg.printErrorPage('System failed to update! !');
	END IF;
	htp.bp('<html><body bgcolor=white><h2> Your password is changed!</h2>
	<font color=blue face=Helvetica> <h3> Please login again if you would like to make any other operation.</h3>
	<form> <b><font color=red size=+1> <input type=button value="CLOSE Session" onClick=top.self.close()></form>
	</font></font>');
	gsystem_pkg.insert_shut_off_scripts(1,0);
	htp.bp('</body></html>');
END changePassword;
--------------------------------------------------------------------
--##################################################################
-- exist
--##################################################################
FUNCTION std_exists(crsTitle IN VARCHAR2,lgn IN vARCHAR2, pwd IN vARCHAR2) RETURN BOOLEAN
IS
	ssn1	VARCHAR2(20);
BEGIN 
	SELECT ssn INTO ssn1 FROM XXstudentsXX s WHERE s.course=crsTitle  AND  s.ssn=lgn AND s.gspwd=pwd;
	return true;
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		--gsystem_pkg.printErrorPage(crsTitle||' '||lgn||pwd||'Unidentified user is trying to access to the system! ');
		return false;
END std_exists;
--------------------------------------------------------------------
--##################################################################
-- studentAccess(unum,course);
--##################################################################
PROCEDURE studentAccess(	unum IN vARCHAR2,course IN VARCHAR2)
IS
	curl	VARCHAR2(200);
BEGIN 
	select url into curl from xxcoursesxx where courseTitle=course;
	htp.bp('
		<html>
		<script language="JavaScript">
function openPrivateWindow(){
		privateWin=open("'||gsystem_pkg.cgi||'std.studentAuthentication?v1='||unum||'&'||'v2='||course||'","PrivateWindow","width=450,height=250,scrollbars=yes,baba=this");
}
		</script>
		<body background=studentin.gif bgcolor=#007a00 link=black vlink=black>
		<IMG SRC="'||gsystem_pkg.images||'clock/0.gif" HEIGHT=1 WIDTH=1>
		<font face="Helvetica" color=yellow>
		<h3>Please close all the windows before you left your desktop in order to reset and secure your access code and passwords!<h3>
		<h4>NPAC cannot be held responsible for the security of your access records if you display
or print this information in a public area. </h4>
<br>
<form action="" method="GET" >
<CENTER>
<table border=8 cellpadding=0 cellspacing=1  width=60% ><th  bgcolor=yellow><FONT SIZE=7 FACE="Helvetica" color=black><b> <a  href="'||curl||'"> '||course||' </a> </b></FONT></th> 
</table>
<table  border=5 cellpadding=0 cellspacing=1 width=60%  bgcolor=black >
<tr><td  bgcolor=tan align=center><FONT SIZE=7 FACE="Helvetica" color=black><b>
<input type=button  value=" LOGIN GRADING SYSTEM " onClick=openPrivateWindow(); > 
</b></FONT><br>  Please note that your initial password is "<font color=red >NPAC</FONT>".
</td></tr>

<tr><td  bgcolor=tan align=center><FONT SIZE=7 FACE="Helvetica" color=black><b>
<input type=button  value=" POST OFFICE " onClick=
onClick=operationWin=open("'||gsystem_pkg.cgi||'std.postOffice?course='||course||'","operationWin","scrollbars=yes,toolbar=no,menubar=no,location=no")
> </b></FONT> 
</td></tr>

<tr><td  bgcolor=tan align=center><FONT SIZE=7 FACE="Helvetica" color=black><b>
<input type=button  value=" CLASS LIST " onClick=
onClick=operationWin=open("'||gsystem_pkg.cgi||'std.classList?course='||course||'","operationWin","scrollbars=yes,toolbar=no,menubar=no,location=no")
> </b></FONT> 
</td></tr>
</table>
</form>
</CENTER>
<hr width=10%>
<hr width=20%>
<hr width=30%>
<hr width=40%>
<hr height=5>
<form action='||gsystem_pkg.cgi||'std.registrationPage
method="GET" target=operationWin>
<input type=hidden name=crsTitle  value="'|| course ||'">
<table cellspacing=1 cellpadding=0 border=0 BORDER=3 WIDTH=100%>
<tr><td  height=10 bgcolor=black align=center> <font face="Helvetica" color=white><b> <sub> '||course||'  '||course||'  '||course||' '||course||' '||course||' '||course||' </font></td> 
</tr>
<tr><td> 
<font  color=springgreen face="Curier,Helvetica">
<h2>New students please sign-up now by clicking below button:</h2>
<b><center><h1>
<input type=submit  value="      Course  Sign-Up     " onClick=operationWin=open("","operationWin","scrollbars=yes,toolbar=no,menubar=no,location=no")>
</b>
</font>
</td>
</tr>
<tr><td  height=10 bgcolor=black align=center> <font face="Helvetica" color=white><b> <sub> '||course||'  '||course||'  '||course||' '||course||' '||course||' '||course||' </font></td> 
</tr>
</table>
</form>
<hr height=50%>
<hr width=40%>
<hr width=30%>
<hr width=20%>
<hr width=10%>
	</body>
	</html>
	');
END studentAccess;
--------------------------------------------------------------------
--##################################################################
-- studentAuthentication(v1,v2);
--##################################################################
PROCEDURE studentAuthentication(	v1 IN vARCHAR2,v2 IN VARCHAR2)
IS					--unum course
BEGIN 
	htp.bp('
<html>
		<script language="JavaScript1.1">
var iamexist=true;
function closeMe(){self.close();}
//alert("If you did not set up your password, your initial password is `NPAC`. Please change your password after login.");
		</script>
<body  background = '||gsystem_pkg.images||'keymarble.jpg>
<form action='||gsystem_pkg.cgi||'std.studentMenu
method="GET" target=operationWin>
<input type=hidden name=unum  value="'|| v1 ||'">
<input type=hidden name=course  value="'|| v2 ||'">
<table cellspacing=1 cellpadding=0 border=0>
<tr>
<td width=200 height=10 bgcolor=black> .</td> <td width=200 height=10 bgcolor=black align=right><font face="Helvetica" color=yellow><b> <sub> '||v2||'  </td>
</tr>
<tr>
<td><b>
Your Personal Access Code : </b>
</td>
<td>
<INPUT TYPE=PASSWORD NAME="lgn" VALUE="" SIZE=15> 
</td>
</tr>
<tr>
<td><b>
Your Student Records Password : </b>
</td>
<td>
<INPUT TYPE=PASSWORD NAME="pwd" VALUE="" SIZE=15> 
</td>
</tr>
<tr>
<td width=200 height=10 bgcolor=black> .</td><td width=200 height=10 bgcolor=black> .</td>
</tr>
<tr>
<td>
<h4><input type=submit  value=" Continue " onClick=operationWin=open("","operationWin","toolbar=no,menubar=no,location=no,scrollbars=yes")> 
</td>
<td align=RIGHT><h4><input type=reset  value=" Cancel " onClick=self.close()> </form> </td>
</tr>
<tr><td></td><td align=RIGHT>
	');
	gsystem_pkg.insert_shut_off_scripts(1,10);
	htp.bp('
</td></tr>
</table>
</body>
</html>
	');
END studentAuthentication;
--------------------------------------------------------------------
--##################################################################
-- studentMenu(unum,course,lgn,pwd);
--##################################################################
PROCEDURE studentMenu(	unum IN vARCHAR2,course IN VARCHAR2,lgn IN vARCHAR2, pwd IN vARCHAR2)
IS
BEGIN 
	htp.bp('
<html>
		<script language="JavaScript1.1">
	');
	if std_exists(course,lgn,pwd) THEN
		htp.bp(' if (opener.iamexist!=null) 
				{opener.close();}	');
	ELSE	htp.bp('
		if (confirm("You typed invalid access code and password combination.Retry?"))
			{  self.close(); }
		else { opener.close(); self.close();}
		');
	END IF;
	htp.bp('
		</script>
<header>
<title>NPAC Student Info Page </title>
</header>
<body  background = '||gsystem_pkg.images||'marble.jpg >
<form action='||gsystem_pkg.cgi||'std.commandServer
method="GET">
<input type=hidden name=unum  value="'|| unum ||'">
<input type=hidden name=course  value="'|| course ||'">
<input type=hidden name=lgn  value="'|| lgn ||'">
<table cellspacing=1 cellpadding=0 border=0>
<tr>
<td width=200 height=10 bgcolor=black> .</td> <td width=200 height=10 bgcolor=black> .</td>
</tr>
<tr>
<td><b>
OPTIONS : </b>
</td>
<td>
</td>
</tr>
<tr>
<td width=200 height=10 bgcolor=black> .</td> <td width=200 height=10 bgcolor=black> .</td>
</tr>
<tr>
<td>
<b>
<IMG SRC='||gsystem_pkg.images||'stdmenu.gif width=45 height=30><input type=submit name=request value=" Course Grades Access     ">
</b>
</td><td <TD ROWSPAN=3> <IMG SRC='||gsystem_pkg.images||'genie.gif></td>
</tr>
<tr>
<td>
<b>
<IMG SRC='||gsystem_pkg.images||'stdmenu.gif align=bottom width=45 height=30><input type=submit name=request value=" Personal Info Access        ">
</b>
</td>
</tr>
<tr>
<td>
<b>
<IMG SRC='||gsystem_pkg.images||'stdmenu.gif width=45 height=30><input type=submit name=request value=" Personal Record Update ">
</b>
</td>
</tr>
<tr>
<td>
<b><h4>
<IMG SRC='||gsystem_pkg.images||'stdmenu.gif width=45 height=30><input type=submit name=request value=" System Password Change ">
</b>
</td><td align=RIGHT><h2>'||course||'</td>
</tr>
<tr><td colspan=2><hr></td></tr><tr><td colspan=2><hr></td></tr>
<tr>
<td>
<b><h4>
<IMG SRC='||gsystem_pkg.images||'stdmenu.gif width=45 height=30><input type=submit name=request value=" Course Survey                  ">
</b>
</td><td></td>
</tr>
<tr>
<td>
<b><h4>
<IMG SRC='||gsystem_pkg.images||'stdmenu.gif width=45 height=30><input type=submit name=request value=" Post Office                       ">
</b>
</td><td></td>
</tr>
<tr>
<td>
<b><h4>
<IMG SRC='||gsystem_pkg.images||'stdmenu.gif width=45 height=30><input type=submit name=request value=" Class List                         ">
</b>
</td><td></td>
</tr>
<tr><td colspan=2><hr></td></tr><tr><td colspan=2><hr></td></tr>
</table>
<input type=hidden name=pwd  value="'|| pwd ||'">
<input type=hidden name=std_id  value=""><input type=hidden name=fname  value=""><input type=hidden name=mname  value=""><input type=hidden name=lname  value=""><input type=hidden name=dept  value=""><input type=hidden name=class  value=""><input type=hidden name=email  value=""><input type=hidden name=xpwd  value=""><input type=hidden name=url  value="">
</form>
<table width=100%>
<tr><td><form> <b><font color=red face=Helvetica size=+1> <input type=button value="CLOSE Session" onClick=top.self.close()></form></td><td align=RIGHT>
	');
	gsystem_pkg.insert_shut_off_scripts(5,0);
	htp.bp('
</td>
</tr>
</table>
</body>
</html>
	');
END studentMenu;
--------------------------------------------------------------------
--##################################################################
-- showGrades(unum,course,ssn);
--##################################################################
PROCEDURE showGrades(unum IN vARCHAR2,course IN VARCHAR2,ssn IN VARCHAR2)
IS
BEGIN
	IF (ssn IS NULL) THEN
		gsystem_pkg.printErrorPage('Access Code, No value entered');
		RETURN;
	END IF;
	ggrading_pkg.commandServer(unum,course,'SHOW_STD',ssn,NULL);
END showGrades;
--------------------------------------------------------------------
--##################################################################
-- showPersonalInfo(unum,course,ssn);
--##################################################################
PROCEDURE showPersonalInfo(unum IN vARCHAR2,crsTitle IN VARCHAR2,ssn IN VARCHAR2)
IS
	std	XXstudentsXX%ROWTYPE;
	myssn VARCHAR2(20);
	MSG BOOLEAN DEFAULT false;
	FOUND BOOLEAN DEFAULT false;
BEGIN
	myssn:=ssn;
	IF NOT unum='a_student' AND ssn IS NULL THEN 
		myssn:='333224444';
	END IF;
	IF (myssn IS NULL) THEN
		gsystem_pkg.printErrorPage('Access Code, No value entered');
		RETURN;
	END IF;
	htp.p('<html>');
	htp.bp('
<body bgcolor=white>  
<b>
	');
	FOR std IN (SELECT *  FROM XXstudentsXX s WHERE (s.ssn=myssn OR myssn='333224444') AND s.course=crsTitle) LOOP
		FOUND:=true;
		htp.bp('
<table bgcolor=blue><th>
<table bgcolor=yellow CELLPADDING=6  border=5  >
<tr><td width=300><b>Student Name</b></td><td>'||	std.firstname ||' '||std.midname||' '||std.lastname||'</td></tr>
<tr><td>	  <b>Student-ID</td><td>'||		std.student_id   ||'</td></tr>
<tr><td>	  <b>Class </b></td><td>'||		std.class ||'</td></tr>
<tr><td>	  <b>Department </b></td><td>'||	std.dept ||'</td></tr>
<tr><td>	  <b>email </b></td><td>'||		std.email ||'</td></tr>
<tr><td>	  <b>Unix login id </b></td><td>'||		std.login ||'</td></tr>
<tr><td>	  <b>Initial Unix Password  </b></td><td><b>'||		std.unixpwd ||'</b>');
		IF ( NOT std.unixpwd IS NULL) THEN
			htp.bp('<br>( Please clean your password from  <br>your records after reading.<sup>*</sup> ) ');
			MSG:=true;
		END IF;
		htp.bp('</td></tr>
<tr><td>	  <b>URL </b></td><td>'||		std.url ||'</td></tr>
</table>
</th>
</table>
<hr>
		');
	END LOOP;
	IF NOT FOUND THEN
		gsystem_pkg.printErrorPage('Access Code is invalid! Please try again.');
	END IF;
	htp.p('</b>');
	IF ( MSG) THEN
		htp.p('<font color=red>* Your password is stored in the database in a non-encrypted format. System group may see your password, which is not the way of password keeping in the unix systems.');
	END IF;
	gsystem_pkg.back;
	htp.p('	<DIV ALIGN=right>');
	gsystem_pkg.insert_shut_off_scripts(5,0);
	htp.bp('
</DIV> </body></html>');
END showPersonalInfo;
--------------------------------------------------------------------
--##################################################################
-- personalRecordUpdatePage(unum,course,ssn);
--##################################################################
PROCEDURE personalRecordUpdatePage(unum IN vARCHAR2,crsTitle IN VARCHAR2,ssn IN VARCHAR2)
IS
	std	XXstudentsXX%ROWTYPE;
	myssn  VARCHAR2(20);
	MSG BOOLEAN DEFAULT false;
	FOUND BOOLEAN DEFAULT false;
BEGIN
	myssn:=ssn;
	IF NOT unum='a_student' AND ssn IS NULL THEN 
		myssn:='333224444';
	END IF;
	IF (myssn IS NULL) THEN
		gsystem_pkg.printErrorPage('Access Code, no value entered');
		RETURN;
	END IF;
	htp.p('<html>');
	htp.bp('
<body bgcolor=white>  
<b>
	');
	FOR std IN (SELECT *  FROM XXstudentsXX s WHERE (s.ssn=myssn OR myssn='333224444') AND s.course=crsTitle) LOOP
		FOUND:=true;
		htp.bp('
<form action='||gsystem_pkg.cgi||'std.commandServer
name="student" method="GET" >
<input type=hidden name=unum  value="'|| unum ||'">
<input type=hidden name=course  value="'|| crsTitle ||'">
<input type=hidden  name=lgn  value="'|| std.ssn ||'">
<b><font color=black size=+1 FACE="Arial,Helvetica" >
<font color=red><input type=submit name=request value="UPDATE" ></font>
<input type=reset  name=request value="UNDO" >
</b></font>
<table bgcolor=black><th>
<table bgcolor=yellow CELLPADDING=6>
<tr><td width=300><b> Student ID</b></td><td><input name=pwd type=hidden value="'||std.gspwd ||'">	<input name=std_ID value="'||std.student_id ||'" size=30></td></tr>
<tr><td width=300><b> Student Name</b></td><td>	
	<table>
		<tr><td><font size=-1>FIRST<font></td><td><input name=fname value="'||std.firstname ||'" size=20></td></tr>
		<tr><td><font size=-1>MIDDLE<font></td><td><input name=mname value="'||std.midname ||'" size=20></td></tr>	
		<tr><td><font size=-1>LAST<font></td><td><input name=lname value="'||std.lastname ||'" size=20></td></tr>
	</table>
</td></tr>
<tr><td>	  <b> Department </b></td><td>	<input name=dept	value="'||std.dept ||'" size=30></td></tr>
<tr><td>	  <b> Class </b></td><td>	<input name=class	value="'||std.class ||'"></td></tr>
<tr><td>	  <b> email </b></td><td>	<input name=email	value="'||std.email ||'" size=30></td></tr>
<tr><td>	  <b> Unix Login Id </b></td><td>'||std.login ||'</td></tr>
<tr><td>	  <b> Initial Unix Password  </b></td><td>	<input name=xpwd value="'||std.unixpwd ||'" size=8>');
	IF ( NOT std.unixpwd IS NULL) THEN
		htp.bp('Please clean your password  from <br>your records after reading.<sup>*</sup>');
		MSG:=true;
	END IF;
		htp.bp('</td></tr>
<tr><td>	  <b >url </b></td><td>		<input name=url		value="'||std.url ||'" size=30></td></tr>
</table>
</th>
</table>
</form>
<hr>
		');
	END LOOP;
	IF NOT FOUND THEN
		gsystem_pkg.printErrorPage('Access Code is invalid! Please try again.');
	END IF;
	htp.p('</b>');
	IF ( MSG) THEN
		htp.p('<font color=red>* Your password is stored in the database in a non-encrypted format. System group may see your password, which is not the way of password keeping in the unix systems.');
	END IF;
	gsystem_pkg.back;
	htp.p('	<DIV ALIGN=right>');
	gsystem_pkg.insert_shut_off_scripts(5,0);
	htp.bp('
</DIV> </body></html>');
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		gsystem_pkg.printErrorPage('Personal Access Code value is invalid');
END personalRecordUpdatePage;
--------------------------------------------------------------------
--##################################################################
-- ChangePasswordPage
--##################################################################
PROCEDURE changePasswordPage(unum IN vARCHAR2,crsTitle IN VARCHAR2,lgn IN VARCHAR2)
IS
	stdgspwd	VARCHAR2(20);
BEGIN
	IF (lgn IS NULL) THEN
		gsystem_pkg.printErrorPage('Access Code, no value entered');
		RETURN;
	END IF;
	htp.p('<html>');
	htp.bp('
<body bgcolor=white>  
<b>
	');
	SELECT gspwd  INTO stdgspwd FROM XXstudentsXX s WHERE (s.ssn=lgn AND s.course=crsTitle);
		htp.bp('
<form action='||gsystem_pkg.cgi||'std.commandServer
name="student" method="GET" >
<input type=hidden name=unum  value="'|| unum ||'">
<input type=hidden name=course  value="'|| crsTitle ||'">
<input type=hidden  name=lgn  value="'|| lgn ||'">
<b><font color=black size=+1 FACE="Arial,Helvetica" >
<font color=red><input type=submit name=request value="CHANGE" ></font>
<input type=reset  name=request value="UNDO" >
<input type=hidden name=pwd value="'||stdgspwd ||'">
<input type=hidden name=std_ID value="">
<input type=hidden type=password name=fname value="yy">
<input type=hidden name=mname value="">
<input type=hidden name=lname value="">
<input type=hidden name=dept	value="xxx">
<input type=hidden name=class	value="">
<input type=hidden name=email	value="">
<input type=hidden name=xpwd	value="">
</b></font>
<table bgcolor=black><th>
<table bgcolor=yellow CELLPADDING=6>
<tr><td width=300><b> Change Grading System Password To </b></td><td>	<input type=password name=url value="'||stdgspwd ||'" size=30></td></tr>
	</table></th>
</table>
</form>
<font color=red size=-1> This password is not your NPAC  Unix Account Password.</font>
<hr>
		');
	htp.p('</b>');
	gsystem_pkg.back;
	htp.p('	<DIV ALIGN=right>');
	gsystem_pkg.insert_shut_off_scripts(1,30);
	htp.bp('
</DIV> </body></html>');
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		gsystem_pkg.printErrorPage(lgn||'Access Code value is invalid'||crsTitle);
END changePasswordPage;
--------------------------------------------------------------------
--##################################################################
-- personalRecordInsert(unum,course,ssn);
--##################################################################
FUNCTION  personalRecordInsert(VcrsTitle IN VARCHAR2,VstdID IN VARCHAR2,Vpwd IN VARCHAR2,Vstd_ID IN NUMBER,Vfname IN VARCHAR2,Vmname IN VARCHAR2,Vlname IN VARCHAR2,Vdept IN VARCHAR2,Vclass IN VARCHAR2,Vemail IN VARCHAR2,Vuid IN VARCHAR2) RETURN BOOLEAN
IS
	std	XXstudentsXX%ROWTYPE;
	myssn NUMBER(9);
BEGIN
	INSERT INTO XXstudentsXX 
	(course,ssn,gspwd,student_id,firstname,midname,lastname,class,dept,email,login)
	VALUES (VcrsTitle,VstdID,Vpwd,Vstd_ID,INITCAP(Vfname),INITCAP(Vmname),INITCAP(Vlname),Vclass,Vdept,Vemail,Vuid);
	COMMIT;
	RETURN true;
	EXCEPTION
		WHEN DUP_VAL_ON_INDEX THEN
			gsystem_pkg.printErrorPage('This user access code exists in the system. You are either trying to get a reserved access code or already registered in the course; if you want to update your records please use another site.');
			RETURN false;
		WHEN INVALID_NUMBER THEN
			gsystem_pkg.printErrorPage('This student access number,'||VstdID||' is not a valid number, please check it and try again!');
			RETURN false;
END personalRecordInsert;
--------------------------------------------------------------------
--##################################################################
-- personalRecordUpdate(unum,course,ssn);
--##################################################################
PROCEDURE personalRecordUpdate(VcrsTitle IN VARCHAR2,VstdID IN VARCHAR2,Vpwd IN VARCHAR2,Vstd_ID IN NUMBER,Vfname IN VARCHAR2,Vmname IN VARCHAR2,Vlname IN VARCHAR2,Vdept IN VARCHAR2,Vclass IN VARCHAR2,Vemail IN VARCHAR2,Vxpwd IN VARCHAR2,Vurl IN VARCHAR2)
IS
	std	XXstudentsXX%ROWTYPE;
	myssn NUMBER(9);
BEGIN
	UPDATE XXstudentsXX s
	SET  	
	s.course=VcrsTitle ,
	s.gspwd=Vpwd,
	s.student_id=Vstd_ID,
	s.firstname=Vfname 	,s.midname=Vmname 	,s.lastname=Vlname 	,
	s.dept=Vdept ,
	s.class=Vclass	,
	s.email =Vemail ,
	s.unixpwd =Vxpwd ,
	s.url =Vurl  
	WHERE s.course=VcrsTitle AND s.ssn=VstdID;
	COMMIT;
	IF SQL%NOTFOUND THEN
		gsystem_pkg.printErrorPage('System failed to update! !');
	END IF;
END personalRecordUpdate;
--------------------------------------------------------------------
--##################################################################
--registrationPage
--##################################################################
PROCEDURE registrationPage(crsTitle IN VARCHAR2)
IS
	category VARCHAR2(30) DEFAULT '---';
	closeTable	BOOLEAN DEFAULT false;
BEGIN
	htp.bp('
<html> <header><title>Class List  Sign-Up</title></header>
<script language=javascript>
function sendForm(form){
	for (var i=0;i<form.elements.length-2;i++){
		if (form.elements[i].checked)
		       this.document.cgi.survey.value+="["+form.elements[i].name+","+form.elements[i].value+"]";
	}
	//alert(this.document.cgi.survey.value);
	this.document.cgi.submit();
}
</script>
	');
	htp.bp('
<body bgcolor=white>
<h1>'||crsTitle||' Student Sign-Up Form</h1>
<h3>Please fill out the form.</h3>');
	htp.p('	<DIV ALIGN=right>');
	gsystem_pkg.insert_shut_off_scripts(10,0);
	htp.bp('</DIV> ');
	htp.bp('
<hr>
<FORM name=cgi method=GET action='||gsystem_pkg.cgi||'std.registration>
<input type=hidden name=crsTitle  value="'||crsTitle||'">
<table bgcolor=yellow>
<tr><td width=300>
<b>Your name</b></td><td>
	<table>
		<tr><td><font size=-1>FIRST<font></td><td><input name=fname value="" size=20></td></tr>
		<tr><td><font size=-1>MIDDLE<font></td><td><input name=mname value="" size=20></td></tr>			<tr><td><font size=-1>LAST<font></td><td><input name=lname value="" size=20></td></tr>
	</table>
</td>
</tr><tr><td>
<b>Personal Access Code  (will be used to login to this system, e.g. Bond007 )</b></td><td><input name=ssn size=9 value="">(<font size=-1 color=blue>do not forget it please</font>) <img src='||gsystem_pkg.images||'key1.gif></td>
</tr><tr><td>
<b>Password  (will be used together with personal access code )</b></td><td><input type=password name=pwd size=9 value="">(<font size=-1 color=blue>do not forget it please</font>) <img src='||gsystem_pkg.images||'lock.gif width=35 height=35></td>
</tr><tr><td>
<b>Student-ID</b></td><td><input name=std_id size=15 value=""> (<font size=-1 color=red>only numeric characters</font>)</td>
</tr><tr><td>
<b>Current email address</b></td><td><input name=email size=30 value=""><br></td>
</tr><tr><td>
<b>If you already have NPAC account, give user id</b></td><td><input name=UID size=30 value=""><br></td>
</tr><tr><td>
<b>Dept./Major</b></td><td><input name=dept size=15 value=""><b>Class
<SELECT Name="class"><OPTION>Pre-College <OPTION>Freshman <OPTION>Sophomore <OPTION>Junior <OPTION>Senior<OPTION>Graduate<OPTION>Professional</SELECT></b></td>
</tr>
</table>
<input type=hidden name=survey  value="">
</form>
<hr>
<h2> COMPUTING SKILLS and GENERAL KNOWLEDGE </h2
<h3>Please complete the inventory below by placing check marks using the following scale:</h3>
0 does not know<br>
1 know a little<br>
2 feel comfortable<br>
3 know a substantial amount<br>
4 expert <br>
<form>
	');
	 FOR q IN (SELECT * FROM XXsurveyListXX s WHERE s.course=crsTitle AND s.surName='registration'  ORDER BY category ASC,qid ASC) LOOP
		IF NOT category=q.category THEN
			htp.p('');
			IF closeTable THEN
				htp.p('</TABLE>');
			END IF;
			htp.p('<h2>'||INITCAP(q.category) ||'</h2>');
			htp.bp('<table bgcolor=pink><tr><td width=300></td><td width=17><b>0</td><td width=17><b>1</td><td width=17 ><b> 2</td><td width=17 ><b> 3</b></td><td width=17><b>4</td></tr>');
			category:=q.category;
			closeTable:=true;
		END IF;
		htp.bp('<tr><td width=300><b>'||q.text||'</b></td><td>	<INPUT type="radio" Name=q'||q.qid||' value=0>');
		htp.bp('<td><INPUT type="radio" Name=q'||q.qid||' value=1></td>
			<td><INPUT type="radio" Name=q'||q.qid||' value=2></td>
			<td><INPUT type="radio" Name=q'||q.qid||' value=3></td>
			<td><INPUT type="radio" Name=q'||q.qid||' value=4><br></td></tr>
		');
	 END LOOP;
	htp.bp('
</table>
<input TYPE =button VALUE = Submit onClick="sendForm(this.form)"><input type =reset  value = Clear></form>');
--	gsystem_pkg.back;
	htp.p('
<form> <b><font color=red size=+1 face=Helvetica > <input type=button value="CLOSE Registration Window" onClick=top.self.close()></font></form>
<hr><i>Mehmet Sen, Ozgur Balsoy</i>');
	htp.p('</body></html>');
END registrationPage;
--------------------------------------------------------------------
--##################################################################
-- nameDuplication(
--##################################################################
FUNCTION  nameDuplication(crsTitle IN VARCHAR2,fname IN  VARCHAR2,mname IN  VARCHAR2,lname IN VARCHAR2) return BOOLEAN
IS
	lid  NUMBER(3);
BEGIN
	htp.bp(fname||' '||mname||' '||lname);
	if mname IS NULL THEN
  		select COUNT(ssn) INTO lid from xxstudentsxx where  course=crsTitle AND fname=UPPER(firstname) AND lname=UPPER(lastname) ;
	ELSE
  		select COUNT(ssn) INTO lid from xxstudentsxx where  course=crsTitle AND fname=UPPER(firstname) AND mname=UPPER(SubStr(midname,1,1)) AND lname=UPPER(lastname) ;
	END IF;
	IF lid > 0 then
		return true;
	else
		return false;
	end if;
END nameDuplication;
--------------------------------------------------------------------
--##################################################################
-- registration;
--##################################################################
PROCEDURE registration(crsTitle IN VARCHAR2,fname IN VARCHAR2,mname IN VARCHAR2,lname IN VARCHAR2,ssn IN VARCHAR2,pwd  IN VARCHAR2,std_id IN NUMBER,email IN VARCHAR2,UID IN VARCHAR2,dept IN VARCHAR2,class IN VARCHAR2,survey IN VARCHAR2)
IS	Vqid 	NUMBER(2);
	Vanswer Number(1);
	ind 		NUMBER(4);
	last 		NUMBER(4);
	input	VARCHAR2(500);
BEGIN

	IF ssn IS NULL THEN
		gsystem_pkg.printErrorPage('You need to write `Personal Access Code` to register..');
		RETURN;
	ELSIF fname IS NULL THEN
		gsystem_pkg.printErrorPage('You need to write your name..');
		RETURN;
	ELSIF lname IS NULL THEN
		gsystem_pkg.printErrorPage('You need to write your last name..');
		RETURN;
	ELSIF pwd IS NULL THEN
		gsystem_pkg.printErrorPage('You need to write `Password` to register..');
		RETURN;
	ELSIF nameDuplication(crsTitle,UPPER(fname),UPPER(SUBSTR(mname,1,1)),UPPER(lname) ) THEN
		gsystem_pkg.printErrorPage('Your name is already in the list.. <h3><font face=Helvetica color=yellow>If you want to change your `Personal Access Code`, please contact with your TA. You can change any other personal information by yourself, by using your `Personal Access Code` and `Password` to access to this system..</font></h3>');
		RETURN;
	END IF;
	input:=survey;
	last:=instr(input,']');
	while last > 0
	loop  --htp.p('<h2>'||input);
		ind:=instr(input,','); 
		Vqid:=TO_NUMBER(substr(input,3,ind-3));
		Vanswer:=TO_NUMBER(substr(input,ind+1,last-ind-1));
		input:=substr(input,last+1);
		last:=instr(input,']');
		--htp.p('<h2>'||Vqid||' -> '||vanswer);
		INSERT INTO XXsurveyXX VALUES (Vqid,crsTitle,'registration',Vanswer,ssn);
	end loop;
	IF NOT personalRecordInsert(crsTitle,ssn,pwd,std_id,fname,mname,lname,dept,class,email,uid) THEN
		RETURN ;
	END IF;
	htp.p('<html><body bgcolor=#ffccff><font color=#ff00ff><h2> You are successfully registered.</h2></font>
	<table border=3><tr><td> <img src='||gsystem_pkg.images||'success.gif></td></tr></table>
');
	gsystem_pkg.back;
	htp.p('	
<form> <b><font color=red size=+1 face=Helvetica> <input type=button value="CLOSE Session" onClick=top.self.close()></font></form>
<DIV ALIGN=right>');
	gsystem_pkg.insert_shut_off_scripts(10,0);
	htp.bp('</DIV> </body></html>');
END registration;
--------------------------------------------------------------------
--##################################################################
-- initializeTable
--##################################################################
PROCEDURE initializeTable(crsTitle IN VARCHAR2,surveyname IN VARCHAR2)
IS
	rec surveyQuestionType;
	n BINARY_INTEGER:=0;
BEGIN 
	FOR q IN (SELECT * FROM XXsurveyListXX s WHERE s.course=crsTitle AND s.surName=surveyname ORDER BY category ASC,qid ASC) LOOP
		n:=q.qid;
		cs(n).id:=n;
		cs(n).c0:=NULL;
		cs(n).c1:=NULL;
		cs(n).c2:=NULL;
		cs(n).c3:=NULL;
		cs(n).c4:=NULL;
		cs(n).b0:=' ';
		cs(n).b1:=' ';
		cs(n).b2:=' ';
		cs(n).b3:=' ';
		cs(n).b4:=' '; COMMIT;
	END LOOP;
END initializeTable;
--------------------------------------------------------------------
--##################################################################
-- 
--##################################################################
PROCEDURE selectSurveytoCourse(crsTitle IN VARCHAR2,surveyname IN VARCHAR2)
IS
	srv	 XXsurveyXX%ROWTYPE;
	n BINARY_INTEGER:=0;
BEGIN 
	FOR srv IN (SELECT * FROM xxsurveyxx WHERE course=crsTitle AND surName=surveyname) LOOP
		n:=srv.qid;
		cs(n).id:=srv.qid;
		IF srv.answer=0 THEN
			cs(n).c0:=cs(n).c0+1 ; cs(n).b0:=cs(n).b0||'|' ; IF cs(n).c0 IS NULL THEN cs(n).c0:=1; END IF;
		ELSIF srv.answer=1 THEN
			cs(n).c1:=cs(n).c1+1 ; cs(n).b1:=cs(n).b1||'|' ; IF cs(n).c1 IS NULL THEN cs(n).c1:=1; END IF;
		ELSIF srv.answer=2 THEN
			cs(n).c2:=cs(n).c2+1 ; cs(n).b2:=cs(n).b2||'|' ; IF cs(n).c2 IS NULL THEN cs(n).c2:=1; END IF;
		ELSIF srv.answer=3 THEN
			cs(n).c3:=cs(n).c3+1 ; cs(n).b3:=cs(n).b3||'|' ; IF cs(n).c3 IS NULL THEN cs(n).c3:=1; END IF;
		ELSIF srv.answer=4 THEN
			cs(n).c4:=cs(n).c4+1 ; cs(n).b4:=cs(n).b4||'|' ; IF cs(n).c4 IS NULL THEN cs(n).c4:=1; END IF;
		END IF;
		COMMIT;
	END LOOP;
END selectSurveytoCourse;
--------------------------------------------------------------------
--##################################################################
-- 
--##################################################################
PROCEDURE surveyStatistics(crsTitle IN VARCHAR2, ssn IN VARCHAR2,surveyname IN VARCHAR2)
IS
	category VARCHAR2(30) DEFAULT '---';
	closeTable	BOOLEAN DEFAULT false;
	q XXsurveyListXX%ROWTYPE;
	n BINARY_INTEGER:=0;
BEGIN 
	initializeTable(crsTitle,surveyname);
	selectSurveytoCourse(crsTitle,surveyname);
	htp.bp('
<html> <header><title>Class Background Evaluation</title></header>
<body bgcolor=white>
<h1>Student Evaluations for course '||crsTitle||'</h1>
0 does not know 1 know a little<br>
2 know a subtantial amount<br>
3 feel comfortable<br>
4 expert <br>
	');
	 FOR q IN (SELECT * FROM XXsurveyListXX s WHERE s.course=crsTitle AND s.surName=surveyname ORDER BY category ASC,qid ASC) LOOP
		IF NOT category=q.category THEN
			htp.p('');
			IF closeTable THEN
				htp.p('</TABLE>');
			END IF;
			htp.p('<h2>'||INITCAP(q.category) ||'</h2>');
				
			htp.bp('<table bgcolor=pink><tr><td width=300></td><td width=15><b>0</td><td width=15><b>1</td><td width=15 ><b> 2</td><td width=15 ><b> 3</b></td><td width=15><b>4</td></tr>');
			category:=q.category;
			closeTable:=true;
		END IF;
	--	htp.p('*'||q.qid||'*');
	--	check_cs(q.qid);
		n:=q.qid;
		htp.bp('<tr><td><b>'||q.text||'</b></td>');
		htp.bp('<td><table><td  bgcolor=green> '||cs(n).b0||'</td><td bgcolor=pink><font color=red size=-1><sup>'||cs(n).c0||'<td></table></td>	');
		htp.bp('<td><table><td  bgcolor=green> '||cs(n).b1||'</td><td bgcolor=pink><font color=red size=-1><sup>'||cs(n).c1||'<td></table></td>	');
		htp.bp('<td><table><td  bgcolor=green>'|| cs(n).b2||'</td><td bgcolor=pink><font color=red size=-1><sup>'||cs(n).c2||'<td></table></td>	');
		htp.bp('<td><table><td  bgcolor=green>'|| cs(n).b3||'</td><td bgcolor=pink><font color=red size=-1><sup>'||cs(n).c3||'<td></table></td>	');
		htp.bp('<td><table><td  bgcolor=green>'|| cs(n).b4||'</td><td bgcolor=pink><font color=red size=-1><sup>'||cs(n).c4||'<td></table></td> </tr>	');
	 END LOOP;
	htp.p('</table><hr>');
	gsystem_pkg.back;
	htp.bp(' </body></html>');
END surveyStatistics;
--------------------------------------------------------------------
--##################################################################
-- surveyMenu
--##################################################################
PROCEDURE surveyMenu(crsTitle IN vARCHAR2,ssn IN VARCHAR2,request IN VARCHAR2)
IS
	previous VARCHAR2(50) :='starting defalut';
BEGIN 
	htp.p('<html>');
	htp.bp('
<body bgcolor=white> 
<h2> Please select from the following survey topics</h2>
 <form action='||gsystem_pkg.cgi||'std.commandServer  method="GET" >
<b>
<input type=hidden name=crsTitle  value="'|| crsTitle ||'">
<input type=hidden  name=ssn  value="'|| ssn ||'">
<input type=hidden  name=request  value="'|| request ||'">
	');
	FOR sl IN (SELECT surName  FROM XXsurveyListXX s WHERE (s.course=crsTitle) ORDER BY surName) LOOP
		IF NOT previous = sl.surName THEN
			htp.bp('
			<input type=radio name=surveyname value="'||sl.surName ||'">'||sl.surName ||'<br>
			');
			previous:=sl.surName ;
		END IF;
	END LOOP;
	htp.bp('
<input type=radio name=surveyname value="" CHECKED><br>
<input type=submit value="          CONTINUE          "></b></font>
</form>
<hr>
	');
	htp.p('</b>');
	gsystem_pkg.back;
	htp.p('	<DIV ALIGN=right>');
	gsystem_pkg.insert_shut_off_scripts(1,0);
	htp.bp('
</DIV> </body></html>');
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		gsystem_pkg.printErrorPage('No survey is prepared yet!');
END surveyMenu;
--------------------------------------------------------------------
--##################################################################
--surveyPage
--##################################################################
PROCEDURE surveyPage(crsTitle IN VARCHAR2,ssn IN VARCHAR2,surveyName IN VARCHAR2)
IS
	category VARCHAR2(30) DEFAULT '---';
	closeTable	BOOLEAN DEFAULT false;
BEGIN
	IF UPPER(surveyName) like '%REGISTRATION%' THEN
		registrationPage(crsTitle); return;
	END IF;
	htp.bp('
<html> <header><title> Survey : '||surveyName||'</title></header>
<script language=javascript>
function sendForm(form){
	for (var i=0;i<form.elements.length-2;i++){
		if (form.elements[i].checked)
		       this.document.cgi.survey.value+="["+form.elements[i].name+","+form.elements[i].value+"]";
	}
	//alert(this.document.cgi.survey.value);
	this.document.cgi.submit();
}
</script>
	');
	htp.bp('
<body bgcolor=white>
<h1>'||crsTitle||' Student '||INITCAP(surveyname)||' Survey  Form</h1>
<h2>Please fill out the form.</h2>
<hr>
<FORM name=cgi method=GET action='||gsystem_pkg.cgi||'std.survey>
<input type=hidden name=crsTitle  value="'||crsTitle||'">
<input type=hidden name=surveyName  value="'||surveyName||'">
<table bgcolor=yellow>
<tr><td width=300>
<b>Your Personal Access Code</b></td><td><input type=password name=pac size=30 value="'||ssn||'"></td>
</tr>
</table>
<input type=hidden name=survey  value="">
</form>
<hr>
<h3>Please complete the inventory below by placing check marks using the following scale:</h3>
0 does not know<br>
1 know a little<br>
2 know a subtantial amount<br>
3 feel comfortable<br>
4 expert <br>
<form>
	');
	 FOR q IN (SELECT * FROM XXsurveyListXX s WHERE s.course=crsTitle AND s.surName=surveyname ORDER BY category ASC,qid ASC) LOOP
		IF NOT category=q.category THEN
			htp.p('');
			IF closeTable THEN
				htp.p('</TABLE>');
			END IF;
			htp.p('<h2>'||INITCAP(q.category) ||'</h2>');
			htp.bp('<table bgcolor=pink><tr><td width=300></td><td width=17><b>0</td><td width=17><b>1</td><td width=17 ><b> 2</td><td width=17 ><b> 3</b></td><td width=17><b>4</td></tr>');
			category:=q.category;
			closeTable:=true;
		END IF;
		htp.bp('<tr><td width=300><b>'||q.text||'</b></td>
		<td>	<INPUT type="radio" Name=q'||q.qid||' value=0></td>
		<td>	<INPUT type="radio" Name=q'||q.qid||' value=1></td>
		<td>	<INPUT type="radio" Name=q'||q.qid||' value=2></td>
		<td>	<INPUT type="radio" Name=q'||q.qid||' value=3></td>
		<td>	<INPUT type="radio" Name=q'||q.qid||' value=4></td></tr>
		');
	 END LOOP;
	htp.bp('
</table>
<input TYPE =button VALUE = Submit onClick="sendForm(this.form)"><input type =reset  value = Clear></form>
<hr><i>Mehmet Sen</i>');
	gsystem_pkg.back;
	htp.p('	<DIV ALIGN=right>');
	gsystem_pkg.insert_shut_off_scripts(10,0);
	htp.bp('
</DIV> </body></html>');
END surveyPage;
--------------------------------------------------------------------
--##################################################################
-- survey;
--##################################################################
PROCEDURE survey(crsTitle IN VARCHAR2, surveyName IN VARCHAR2,pac IN NUMBER,survey IN VARCHAR2)
IS	Vqid 	NUMBER(2);
	Vanswer Number(1);
	ind 		NUMBER(4);
	last 		NUMBER(4);
	input	VARCHAR2(500);
BEGIN
	IF pac IS NULL THEN
		gsystem_pkg.printErrorPage('You need to write SSN number to complete survey...');
		RETURN;
	END IF;
	input:=survey;
	last:=instr(input,']');
	while last > 0
	loop  --htp.p('<h2>'||input);
		ind:=instr(input,','); 
		Vqid:=TO_NUMBER(substr(input,3,ind-3));
		Vanswer:=TO_NUMBER(substr(input,ind+1,last-ind-1));
		input:=substr(input,last+1);
		last:=instr(input,']');
		--htp.p('<h2>'||Vqid||' -> '||vanswer);
		INSERT INTO XXsurveyXX VALUES (Vqid,crsTitle,surveyName,Vanswer,pac);
	end loop;
	htp.p('<html><body bgcolor=#ffccff><font color=#ff00ff><h2> Thank you for completing the survey.</h2></font>');
	gsystem_pkg.back;
	htp.p('</body></html>');
	EXCEPTION
		WHEN DUP_VAL_ON_INDEX THEN
			gsystem_pkg.printErrorPage('You are already completed the survey, filling the form again is not allowed!.');
END survey;
--------------------------------------------------------------------
--##################################################################
-- commandServer
--##################################################################
PROCEDURE commandServer(
	unum IN vARCHAR2,
	course IN VARCHAR2,
	lgn IN VARCHAR2,request IN VARCHAR2,
	pwd IN VARCHAR2,
	 std_id IN NUMBER,fname IN VARCHAR2,mname IN VARCHAR2,lname IN VARCHAR2,dept IN VARCHAR2,class IN VARCHAR2,email IN VARCHAR2,xpwd IN VARCHAR2,url IN VARCHAR2)
IS
BEGIN 
	IF request LIKE '%Post Office%' THEN
		gutil_pkg.utilManipulationPage(	'evrubody',course,request);
		RETURN;
	ELSIF  request LIKE '%Class List%' THEN
		gutil_pkg.utilManipulationPage(	'evrubody',course,'E-mail List');
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT unum='a_student' AND NOT gsystem_pkg.accessPermit(unum,course,'std:'||request) THEN
		RETURN;
	END IF;
	IF unum='a_student' AND NOT std_exists(course,lgn,pwd) THEN
		gsystem_pkg.printErrorPage('Access denied! ');
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF request LIKE '%Course Grades Access%' THEN
		showGrades(unum,course,lgn);
	ELSIF  request LIKE '%Personal Info Access%' THEN
		showPersonalInfo(unum,course,lgn);
	ELSIF  request LIKE '%Personal Record Update%' THEN
		personalRecordUpdatePage(unum,course,lgn);
	ELSIF  request LIKE '%System Password Change%' THEN
		changePasswordPage(unum,course,lgn);
	ELSIF  request LIKE '%UPDATE%' THEN
		personalRecordUpdate(course,lgn,pwd,std_id,fname,mname,lname,dept,class,email,xpwd,url);
		showPersonalInfo(unum,course,lgn);
	ELSIF  request LIKE '%CHANGE%' THEN
		changePassword(course,lgn,url);
	ELSIF UPPER(request) LIKE '%SIGN-UP%' THEN
		registrationPage(course);
	ELSIF UPPER(request) LIKE '%SURVEY STATISTICS%' THEN
		surveyMenu(course,lgn,'SURVEY STATISTICS');
	ELSIF UPPER(request) LIKE '%COURSE SURVEY%' THEN	
		surveyMenu(course,lgn,'COURSE SURVEY');
	END IF;
END commandServer;
--------------------------------------------------------------------
--##################################################################
-- commandServer
--##################################################################
PROCEDURE commandServer(crsTitle IN VARCHAR2,ssn IN VARCHAR2,request IN VARCHAR2,surveyname IN VARCHAR2)
IS
BEGIN 
	IF  request LIKE '%SURVEY STATISTICS%' THEN
		surveyStatistics(crsTitle,ssn,surveyname);
	ELSIF UPPER(request) LIKE '%COURSE SURVEY%' THEN	
		surveyPage(crsTitle,ssn,surveyname);
	END IF;
END commandServer;
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
END std;
/
show err
